# preliminary work and other checks

# conda activate basic_science
# every python3.8 package used is listed in environment.yml 
# we use miniconda

## code
- /code/evaluation_def.nb: contains checks of Jovan and Marco analytical results, Jovan's derivations is located elsewere
- /code/mapping.nb: a Mathematica implementation of the mapping between the W and kink W state
- /code/Pauli.m: is a package needed to run mapping.nb content
- /code/closed_form_study.py: code that evaluates all the possible Pauli strings on the kink W state
- /code/TFIM_W_kink.py: Tobias code to map kink W state to W state
- /code/mapping_code_new.py: Jovan code to map kink W state to W state
- /code/frustratedmagic.py: analytic formula comparison with small magnetic field stuff
- /code/many_body_state_magic_evaluation.py: take a many-body state and evaluate all the string operators 
- /code/singlecopy.py: compute the single copy magic as hamma did in https://arxiv.org/abs/2205.02247, Figure 1b inset
- /code/compare.py: compare the results for smaller and smaller magnetic field and the kink W state (W state) result

## data
In this folder there is only comparison magic data for the TFIM with varying magnetic field an increasing system size

## dependencies
- dependencies.py: contains all the necessary functions to execute the codes in /code/ folder, most of the functions are not properly documented
- aps2column.mplstyle: plotting style of stuff

## plots
- plots/Fig1/main.tex: contains a standalone tikz tex file that can be complied on overleaf and colored accordingly 


