"""

Magic state testing. Testing how with smaller h we approach the results from the W state. 

"""

import numpy as np
from itertools import combinations
from scipy import linalg
from scipy.sparse.linalg import LinearOperator, eigsh
import math
from numpy import linalg as LA
from math import e
import time

import sys
sys.path.append("../dependencies")
from dependencies import *

import matplotlib as mpl
import matplotlib.pyplot as plt
plt.style.use('thesis')
import csv

import itertools



data = np.genfromtxt('../data/output.dat')
anax = data[:, 0]
anay = data[:, 1]

data = np.genfromtxt('../data/h05.dat')
anaxh05 = data[:, 0]
anayh05 = data[:, 1]

data = np.genfromtxt('../data/h03.dat')
anaxh03 = data[:, 0]
anayh03 = data[:, 1]

data = np.genfromtxt('../data/h02.dat')
anaxh02 = data[:, 0]
anayh02 = data[:, 1]

data = np.genfromtxt('../data/h01.dat')
anaxh01 = data[:, 0]
anayh01 = data[:, 1]

data = np.genfromtxt('../data/h0001.dat')
anaxh0001 = data[:, 0]
anayh0001 = data[:, 1]

data = np.genfromtxt('../data/h000001.dat')
anaxh000001 = data[:, 0]
anayh000001 = data[:, 1]

markerll = ["o", "v", "^", "D", "d", "*", "s"]


analy = [anay[1],anay[2],anay[3],anay[4],anay[5]]
print('aa',analy)
# IMMEDIATELY PLOTTING ! 
fig = plt.figure()
grid = plt.GridSpec(1, 1, wspace=0.1, hspace=0.3)
ax = fig.add_subplot(grid[0, 0])

ax.plot(anax,anay,alpha=1.0,color='black',rasterized=True,label=r'Analytical kink state $h = 0$')
ax.plot(anaxh05,anayh05,alpha=1.0,color='green',marker=markerll[1],rasterized=True,label=r'$h = 0.5$')
ax.plot(anaxh03,anayh03,alpha=1.0,color='red',marker=markerll[2],rasterized=True,label=r'$h = 0.3$')
#ax.plot(anaxh02,anayh02,alpha=1.0,rasterized=True,label=r'$h = 0.2$')
ax.plot(anaxh01,anayh01,alpha=1.0,color='blue',marker=markerll[3],rasterized=True,label=r'$h = 0.1$')
ax.plot(anaxh0001,anayh0001,alpha=1.0,color='magenta',marker=markerll[4],rasterized=True,label=r'$h = 0.001$')
#ax.plot(anaxh000001,anayh000001,alpha=1.0,rasterized=True,label=r'$h = 0.00001$')



ax.set_xlabel(r' spin number $N$')
ax.set_ylabel(r' 2-stabilizer Rényi entropy $\mathcal{M}_{2} (h)$')
ax.grid(True,alpha=0.2)
ax.tick_params( which='major',bottom=True,top=True,left=True,right=True,labeltop=False,labelbottom=True)
ax.legend(ncol=1,loc='best',fontsize='15')
#ax.set_xscale('log')
#ax.set_yscale('log')

ax.set_xlim([2,12])
ax.set_ylim([0.2,3.5])

# INSET
left, bottom, width, height = [0.56, 0.205, 0.3, 0.3]
ax1 = fig.add_axes([left, bottom, width, height])

ax1.plot(anaxh05,np.abs(analy - anayh05),alpha=1.0,color='green',marker=markerll[1],rasterized=True,label=r'$h = 0.5$')
ax1.plot(anaxh03,np.abs(analy - anayh03),alpha=1.0,color='red',marker=markerll[2],rasterized=True,label=r'$h = 0.3$')
ax1.plot(anaxh01,np.abs(analy - anayh01),alpha=1.0,color='blue',marker=markerll[3],rasterized=True,label=r'$h = 0.1$')
ax1.plot(anaxh0001,np.abs(analy - anayh0001),alpha=1.0,color='magenta',marker=markerll[4],rasterized=True,label=r'$h = 0.001$')


ax1.tick_params( which='major',bottom=True,top=True,left=True,right=True,labeltop=False,labelbottom=True,labelsize='22')
ax1.set_yscale('log')


ax1.set_xlabel(r' spin number $N$ ',fontsize=20,labelpad=-3.5)    
ax1.set_ylabel(r' $\vert \mathcal{M}_{2} (h) - \mathcal{M}_{2} (0) \vert $ ',fontsize=25)
ax1.grid(True,alpha=0.2)


plt.savefig("compare.png", dpi=300)
plt.show()    









