"""

Magic state testing

"""

import numpy as np
from itertools import combinations
from scipy import linalg
from scipy.sparse.linalg import LinearOperator, eigsh
import math
from numpy import linalg as LA
from math import e
import time

import sys
sys.path.append("../dependencies")
from dependencies import *

import matplotlib as mpl
import matplotlib.pyplot as plt
plt.style.use('thesis')

import itertools

# this dumb function doesn't work when in dependecies.py file so we put it here
def doApplyHamClosed(psiIn):
    """ supplementary function  cast the Hamiltonian 'H' as a linear operator """
    return doApplyHamTENSOR(psiIn, hloc, N, usePBC)



alpha = 2.0

# import Pauli gates    
sX, sY, sZ, sI = PauliMatrice()

x = []
y = []
for N in range(3,9,2):

    #magic = generate_kink_state(N,1)
    #magic = generate_normal_state(N)
    magic = generate_kink_stateXY(N,1, (np.pi/2.0)*(1.0 - 1.0/N))


    # basic computations
    gate_list = [sI,sX,sY,sZ]
    gate_list_id = [0,1,2,3]

    temp = [p for p in itertools.product(gate_list_id, repeat=N)]
    #print('temp', temp)

    kk = 0.0
    tampon = 0.0
    for i in range(0,len(temp)):

        gate = gate_list[temp[i][0]]
        for j in range(1,len(temp[i])):
            gate = np.kron(gate,gate_list[temp[i][j]])


        theta =  (2.0**(-N))*(np.conjugate(np.transpose(magic)) @ gate @ magic)**(2.0)
        #print('theta=',i,theta)

        kk = kk + theta

        tampon = tampon + theta**alpha


    value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)


    x.append(N)
    y.append(value_numerical.real)

    print('x,y = ', N, value_numerical.real)

print(x,y)

"""
xXY = []
yXY = []
for N in range(3,9,2):

    magic = generate_kink_stateXY(N,1, (np.pi/2.0)*(1.0 - 1.0/N))
    #magic = generate_normal_state(N)

    # basic computations
    gate_list = [sI,sX,sY,sZ]
    gate_list_id = [0,1,2,3]

    temp = [p for p in itertools.product(gate_list_id, repeat=N)]
    #print('temp', temp)

    kk = 0.0
    tampon = 0.0
    for i in range(0,len(temp)):

        gate = gate_list[temp[i][0]]
        for j in range(1,len(temp[i])):
            gate = np.kron(gate,gate_list[temp[i][j]])


        theta =  (2.0**(-N))*(np.conjugate(np.transpose(magic)) @ gate @ magic)**(2.0)
        #print('theta=',i,theta)

        kk = kk + theta

        tampon = tampon + theta**alpha


    value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)


    xXY.append(N)
    yXY.append(value_numerical.real)

    print('x,y = ', N, value_numerical.real)

print(xXY,yXY)
"""





xfullstate1 = []
yfullstate1 = []
for N in range(3,9,1):
    usePBC = True             # use periodic or open boundaries
    numval = 1                # number of eigenstates to compute- np.exp(1j*np.pi/4.0).real

    hloc = tfim_LocalHamiltonian_new(10.0)

    H = LinearOperator((2**N, 2**N), matvec=doApplyHamClosed)

    eigenvalues, eigenvectors = eigsh(H, k=numval, which='SA',return_eigenvectors=True)

    idx = eigenvalues.argsort()[::1]   
    eigenvalues = eigenvalues[idx]
    eigenvectors = eigenvectors[:,idx]

    magic = eigenvectors[:,0]
    #magic = generate_normal_state(N)

    # basic computations
    gate_list = [sI,sX,sY,sZ]
    gate_list_id = [0,1,2,3]

    temp = [p for p in itertools.product(gate_list_id, repeat=N)]
    #print('temp', temp)

    kk = 0.0
    tampon = 0.0
    for i in range(0,len(temp)):

        gate = gate_list[temp[i][0]]
        for j in range(1,len(temp[i])):
            gate = np.kron(gate,gate_list[temp[i][j]])


        theta =  (2.0**(-N))*(np.conjugate(np.transpose(magic)) @ gate @ magic)**(2.0)
        #print('theta=',i,theta)

        kk = kk + theta

        tampon = tampon + theta**alpha


    value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)


    xfullstate1.append(N)
    yfullstate1.append(value_numerical.real)

    print('x,y = ', N, value_numerical.real)

print(xfullstate1,yfullstate1)


xfullstate2 = []
yfullstate2 = []
for N in range(3,9,1):
    usePBC = True             # use periodic or open boundaries
    numval = 1                # number of eigenstates to compute- np.exp(1j*np.pi/4.0).real

    hloc = tfim_LocalHamiltonian_new(-10.0)

    H = LinearOperator((2**N, 2**N), matvec=doApplyHamClosed)

    eigenvalues, eigenvectors = eigsh(H, k=numval, which='SA',return_eigenvectors=True)

    idx = eigenvalues.argsort()[::1]   
    eigenvalues = eigenvalues[idx]
    eigenvectors = eigenvectors[:,idx]

    magic = eigenvectors[:,0]
    #magic = generate_normal_state(N)

    # basic computations
    gate_list = [sI,sX,sY,sZ]
    gate_list_id = [0,1,2,3]

    temp = [p for p in itertools.product(gate_list_id, repeat=N)]
    #print('temp', temp)

    kk = 0.0
    tampon = 0.0
    for i in range(0,len(temp)):

        gate = gate_list[temp[i][0]]
        for j in range(1,len(temp[i])):
            gate = np.kron(gate,gate_list[temp[i][j]])


        theta =  (2.0**(-N))*(np.conjugate(np.transpose(magic)) @ gate @ magic)**(2.0)
        #print('theta=',i,theta)

        kk = kk + theta

        tampon = tampon + theta**alpha


    value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)


    xfullstate2.append(N)
    yfullstate2.append(value_numerical.real)

    print('x,y = ', N, value_numerical.real)

print(xfullstate2,yfullstate2)

"""
xfullstate3 = []
yfullstate3 = []
for N in range(3,9,2):
    usePBC = True             # use periodic or open boundaries
    numval = 1                # number of eigenstates to compute- np.exp(1j*np.pi/4.0).real

    hloc = tfim_LocalHamiltonian_new(1.0)

    H = LinearOperator((2**N, 2**N), matvec=doApplyHamClosed)

    eigenvalues, eigenvectors = eigsh(H, k=numval, which='SA',return_eigenvectors=True)

    idx = eigenvalues.argsort()[::1]   
    eigenvalues = eigenvalues[idx]
    eigenvectors = eigenvectors[:,idx]

    magic = eigenvectors[:,0]
    #magic = generate_normal_state(N)

    # basic computations
    gate_list = [sI,sX,sY,sZ]
    gate_list_id = [0,1,2,3]

    temp = [p for p in itertools.product(gate_list_id, repeat=N)]
    #print('temp', temp)

    kk = 0.0
    tampon = 0.0
    for i in range(0,len(temp)):

        gate = gate_list[temp[i][0]]
        for j in range(1,len(temp[i])):
            gate = np.kron(gate,gate_list[temp[i][j]])


        theta =  (2.0**(-N))*(np.conjugate(np.transpose(magic)) @ gate @ magic)**(2.0)
        #print('theta=',i,theta)

        kk = kk + theta

        tampon = tampon + theta**alpha


    value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)


    xfullstate3.append(N)
    yfullstate3.append(value_numerical.real)

    print('x,y = ', N, value_numerical.real)

print(xfullstate3,yfullstate3)
"""

approxX = []
approxY = []
for i in range(3,15,2):
    approxX.append(i)
    #approxY.append(-(1-i)*np.log(4.0) - np.log(1.0 + i*i) ) 
    approxY.append(i*np.log(4.0) - np.log(4.0 + 4.0*i*i + i*i*((i - 1)**2.0)) ) 



data = np.genfromtxt('../data/output.dat')
anax = data[:, 0]
anay = data[:, 1]




# IMMEDIATELY PLOTTING ! 
fig = plt.figure()
grid = plt.GridSpec(1, 1, wspace=0.1, hspace=0.3)
ax = fig.add_subplot(grid[0, 0])

#ax.scatter(x,y,alpha=1.0,rasterized=True,label=r'kink state ISING')
#ax.plot(x,y,alpha=1.0,rasterized=True)

ax.plot(anax,anay,alpha=1.0,rasterized=True,label=r'Analytical')

#ax.scatter(xXY,yXY,alpha=1.0,rasterized=True,label=r'kink state XY')
#ax.plot(xXY,yXY,alpha=1.0,rasterized=True)

#ax.scatter(xfullstate1,yfullstate1,alpha=1.0,rasterized=True,label=r'many-body state ISING $J/h = 10.0$ frustrated')
#ax.plot(xfullstate1,yfullstate1,alpha=1.0,rasterized=True)

#ax.scatter(xfullstate2,yfullstate2,alpha=1.0,rasterized=True,label=r'many-body state ISING $J/h = -10.0$ unfrustated')
#ax.plot(xfullstate2,yfullstate2,alpha=1.0,rasterized=True)

#ax.plot(approxX,approxY,label='approximate formula')

ax.set_xlabel(r' spin number $N$')
ax.set_ylabel(r' magic ')
ax.grid(True,alpha=0.2)
ax.tick_params( which='major',bottom=True,top=True,left=True,right=True,labeltop=False,labelbottom=True)
ax.legend(ncol=1,loc='best',fontsize='15')
#ax.set_xscale('log')
#ax.set_yscale('log')

#ax.set_xlim([1,1000000])
#ax.set_ylim([-0.1,1.3])

# INSET
left, bottom, width, height = [0.5, 0.35, 0.225, 0.225]
ax1 = fig.add_axes([left, bottom, width, height])

#ax1.scatter(x,y,alpha=1.0,rasterized=True,label=r'kink state ISING')
#ax1.plot(x,y,alpha=1.0,rasterized=True)
ax1.plot(anax,anay,alpha=1.0,rasterized=True,label=r'Analytical')
ax1.scatter(xfullstate1,yfullstate1,alpha=1.0,color='red',rasterized=True,label=r'many-body state ISING $J/h = 10.0$ frustrated')
ax1.plot(xfullstate1,yfullstate1,alpha=1.0,color='red',rasterized=True)

#ax1.scatter(xfullstate2,yfullstate2,alpha=1.0,rasterized=True,label=r'many-body state ISING $J/h = -10.0$ unfrustated')
#ax1.plot(xfullstate2,yfullstate2,alpha=1.0,rasterized=True)

ax1.tick_params( which='major',bottom=True,top=True,left=True,right=True,labeltop=False,labelbottom=True,labelsize='22')
ax1.set_xlim([2,10])
ax1.set_ylim([0,3])


ax1.set_xlabel(r' $N$ ',fontsize=20,labelpad=-3.5)    
ax1.set_ylabel(r' magic ',fontsize=25)
#ax1.set_xticks(xxinset)

ax1.grid(True,alpha=0.2)



plt.savefig("FrustratedMagic.png", dpi=300)
plt.show()    









