"""

General many-body state evaluation. 

Given a state from ED calculation, compute all the Pauli strings and the corresponding magic.


"""

import numpy as np
from itertools import combinations
from scipy import linalg
from scipy.sparse.linalg import LinearOperator, eigsh
import math
from numpy import linalg as LA
from math import e
import time

import sys
sys.path.append("../dependencies")
from dependencies import *

import matplotlib as mpl
import matplotlib.pyplot as plt

import itertools

# this dumb function doesn't work when in dependecies.py file so we put it here
def doApplyHamClosed(psiIn):
    """ supplementary function  cast the Hamiltonian 'H' as a linear operator """
    return doApplyHamTENSOR(psiIn, hloc, N, usePBC)



N = 5
alpha = 2.0



# import Pauli gates    
sX, sY, sZ, sI = PauliMatrice()

# define the magic state of general dimension N
zero = [1.0 + 0.0*1j,0.0 + 0.0*1j]
one  = [0.0 + 0.0*1j,1.0 + 0.0*1j]
#magic0 = (2.0**(-1.0/2.0))*(zero  + np.exp((1.0*1j*np.pi)/4.0)*np.asarray(one) )
#magic  = (2.0**(-1.0/2.0))*(zero  + np.exp(1.0*(1j*np.pi)/4.0)*np.asarray(one) )

#for i in range(1,N):
#    magic = np.kron(magic0,magic)

#magic = (1.0/(np.sqrt(3.0)))*( np.kron(zero,np.kron(zero,one)) + np.kron(one,np.kron(zero,zero)) + np.kron(zero,np.kron(one,zero)) )
#magic = (1.0/(np.sqrt(6.0)))*( np.kron(zero,np.kron(zero,one)) + np.kron(one,np.kron(zero,zero)) + np.kron(zero,np.kron(one,zero)) + np.kron(one,np.kron(one,zero)) + np.kron(zero,np.kron(one,one)) + np.kron(one,np.kron(zero,one)))
#magic = generate_kink_stateXY(N,1, (np.pi/2.0)*(1.0 - 1.0/N))
#print('state = ', magic, magic.shape)


usePBC = True             # use periodic or open boundaries
numval = 1                # number of eigenstates to compute- np.exp(1j*np.pi/4.0).real

hloc = tfim_LocalHamiltonian_test(0.01)
H = LinearOperator((2**N, 2**N), matvec=doApplyHamClosed)

eigenvalues, eigenvectors = eigsh(H, k=numval, which='SA',return_eigenvectors=True)

idx = eigenvalues.argsort()[::1]   
eigenvalues = eigenvalues[idx]
eigenvectors = eigenvectors[:,idx]

magic = eigenvectors[:,0]
print('energy = ', eigenvalues)


#magic = generate_kink_state(N,1)


#print('magic =', magic)

# basic computations
gate_list = [sI,sX,sY,sZ]
gate_list_id = [0,1,2,3]

temp = [p for p in itertools.product(gate_list_id, repeat=N)]
#print('temp', temp)

kk = 0.0
tampon = 0.0
for i in range(0,len(temp)):

    gate = gate_list[temp[i][0]]
    for j in range(1,len(temp[i])):
        gate = np.kron(gate,gate_list[temp[i][j]])


    theta =  (2.0**(-N))*(np.conjugate(np.transpose(magic)) @ gate @ magic)**(2.0)
    #print('theta=',i,theta)

    kk = kk + theta

    tampon = tampon + theta**alpha

print('normalization =', kk)

value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)
print('numerical value=', value_numerical)




"""
# IMMEDIATELY PLOTTING ! 
fig = plt.figure()
grid = plt.GridSpec(1, 1, wspace=0.1, hspace=0.3)
ax = fig.add_subplot(grid[0, 0])

ax.plot(x,y,alpha=1.0,rasterized=True,label=r'magic')


ax.set_xlabel(r' spin number $N$')
ax.set_ylabel(r' magic ')
ax.grid(True,alpha=0.2)
ax.tick_params( which='major',bottom=True,top=True,left=True,right=True,labeltop=False,labelbottom=True)
ax.legend(ncol=1,loc='lower left',fontsize='15')
#ax.set_xscale('log')
#ax.set_yscale('log')

#ax.set_xlim([1,1000000])
#ax.set_ylim([-0.1,1.3])


plt.savefig("FrustratedMagic.png", dpi=300)
plt.show()    


"""






