# code to move from W state to kink W state


import numpy as np
from itertools import combinations
from scipy import linalg
from scipy.sparse.linalg import LinearOperator, eigsh
import math
from numpy import linalg as LA
from scipy.optimize import curve_fit

import sys
sys.path.append("../dependencies")
from dependencies import *



# auxiliry code to generate bit strings of size N
def numberToBase(n, b,n_qubits):
    if n == 0:
        return np.zeros(n_qubits,dtype=int)
    digits = np.zeros(n_qubits,dtype=int)
    counter=0
    while n:
        digits[counter]=int(n % b)
        n //= b
        counter+=1
    return digits[::-1]


def CNOT_gate(N,i,j):


	# generate the whole basis
	base_states=np.array([numberToBase(i, 2,N) for i in range(2**N)],dtype=int)
	# copy the states because we use base_states as auxilary
	list1 = base_states.copy()

	# list through all the 2**N states and apply the CNOT gate rules and produce a new list
	list2 = []
	for k in range(0,2**N):


		if ( (base_states[k,i-1] == 0) and (base_states[k,j-1] == 0) ):
			pass
		
		elif ( (base_states[k,i-1] == 0) and (base_states[k,j-1] == 1) ):
			pass
		elif ( (base_states[k,i-1] == 1) and (base_states[k,j-1] == 0) ):
			base_states[k,i-1] = 1
			base_states[k,j-1] = 1

		elif ( (base_states[k,i-1] == 1) and (base_states[k,j-1] == 1) ):
			base_states[k,i-1] = 1
			base_states[k,j-1] = 0
		
		list2.append(base_states[k])

	# generate a matrix of zeros
	matrix = np.zeros([2**N,2**N])

	# now compare list1 and list2 which are the indices of the full dimensionality CNOT gate, only N are one, remaining ones are zero
	for k in range(0,len(list1)):
		kk1 = ''.join(map(str,list1[k]))
		kk2 = ''.join(map(str,list2[k]))

		matrix[int(kk1,2),int(kk2,2)] = 1
	

	return matrix


def string_single_qubit_operation(N,gate,where):

    sX, sY, sZ, sI = PauliMatrice()

    # generate the ordered list of the operators
    lista = []
    for i in range(0,N):
    	if (i == where-1 ):
    		lista.append(gate)
    	else:
    		lista.append(sI)

    #print('hahha',lista)

    # make the tensor product of the predescribed list
    matrix = lista[N-1]
    for i in range(1,N):
    	#print('WOW',i,N-i)
    	matrix = np.kron(lista[N - i - 1],matrix)

    return matrix	



# define the system size (odd number always)
N = 5

# define Pauli gates for later use
sX, sY, sZ, sI = PauliMatrice()
Hadamard = (1.0/np.sqrt(2.0))*np.array([[1.0, 1.0], [1.0, -1.0]])

################################################ KINK STATE ####################
kink_state = generate_kink_stateTOT(N,1) 


################################################ W STATE #######################
W_state = generate_kink_stateW(N)



############# APPLY FIRST CNOT GATES ########################
string = W_state.copy()

print('testing =', string)

# first
cnot_string1 = CNOT_gate(N,1,2)
for i in range(1,N-1):
	index = i + 1
	cnot_string1 = CNOT_gate(N,index,index+1) @ cnot_string1
	

string = cnot_string1 @ W_state 

# second
string = string_single_qubit_operation(N,sX,N) @ string
string = string_single_qubit_operation(N,Hadamard,N) @ string

#print('hadamard =', string_single_qubit_operation(N,Hadamard,N))


# third
for i in range(0,math.floor(N/2)):
	index = i + 1

	string = string_single_qubit_operation(N,sX,2*index - 1) @ string

# fourth
cnot_string2 = CNOT_gate(N,N,N-1)
for i in range(1,N-1):
	index = i + 1
	cnot_string2 = CNOT_gate(N,N,N-index) @ cnot_string2
	

string = cnot_string2 @ string


print('-------------END-------------')
print('transformed state')
print(string)
print('---------------------')
print('kink state')
print(kink_state)

