"""

Magic state testing

"""

import numpy as np
from itertools import combinations
from scipy import linalg
from scipy.sparse.linalg import LinearOperator, eigsh
import math
from numpy import linalg as LA
from math import e
import time

import sys
sys.path.append("../dependencies")
from dependencies import *

import matplotlib as mpl
import matplotlib.pyplot as plt

import itertools

from scipy.integrate import quad

# this dumb function doesn't work when in dependecies.py file so we put it here
def doApplyHamClosed(psiIn):
    """ supplementary function  cast the Hamiltonian 'H' as a linear operator """
    return doApplyHamTENSOR(psiIn, hloc, N, usePBC)

def f(x):

    func = - (lambdaa - np.cos(x))/np.sqrt(np.sin(x)**2.0 + (lambdaa - np.cos(x))**2.0)

    return - (1.0/np.pi)*func


h = 1.1
gamma = 1.0
r = 0.0

x = []
y = []

for i in range(1,20000,1):
    h = 0.0001*i
    N = 1001
    #diff = XY_E_e_2(N,h,gamma) - XY_E_o_1(N,h,gamma) 

    G = g_0_10(N,r,h,gamma) + g_1_10(N,r,h,gamma)

    M = np.log((1.0 + G**2.0)/(1.0 + G**4.0))

    print(h,G,M)
    x.append(1.0/h)
    y.append(M)


xhamma = []
yhamma = []
for i in range(1,20000,1):
    lambdaa = 0.0001*i
    
    res, err = quad(f, 0, np.pi)

    M = np.log((1.0 + res**2.0)/(1.0 + res**4.0))


    xhamma.append(1.0/lambdaa)
    yhamma.append(M)
    print('res , err =',M,err)

"""
print(' ----------- Exact Diagonalization ----------- ')
N = 15
usePBC = True             # use periodic or open boundaries
numval = 1                # number of eigenstates to compute- np.exp(1j*np.pi/4.0).real
sX, sY, sZ, sI = PauliMatrice()

hloc = tfim_LocalHamiltonian_proper(h)
H = LinearOperator((2**N, 2**N), matvec=doApplyHamClosed)

eigenvalues, eigenvectors = eigsh(H, k=numval, which='SA',return_eigenvectors=True)

idx = eigenvalues.argsort()[::1]   
eigenvalues = eigenvalues[idx]
eigenvectors = eigenvectors[:,idx]

psi = eigenvectors[:,0]



for jj in range(1,N+1):
    magz = local_magnetization_single_point(sZ,jj,psi,N,2)
    print('N,jj,magz =',N,jj,magz)
"""


"""
# import Pauli gates    
sX, sY, sZ, sI = PauliMatrice()

array_N  = []
array_mz = []

for N in range(3,5):
    usePBC = True             # use periodic or open boundaries
    numval = 1                # number of eigenstates to compute- np.exp(1j*np.pi/4.0).real

    hloc = tfim_LocalHamiltonian_new(-1.0)
    H = LinearOperator((2**N, 2**N), matvec=doApplyHamClosed)

    eigenvalues, eigenvectors = eigsh(H, k=numval, which='SA',return_eigenvectors=True)

    idx = eigenvalues.argsort()[::1]   
    eigenvalues = eigenvalues[idx]
    eigenvectors = eigenvectors[:,idx]

    psi = eigenvectors[:,0]


    magz = 0
    for jj in range(1,N+1):
        magz += local_magnetization_single_point(sZ,jj,psi,N,2)

    print('magz =', N,magz)


    alpha = 2.0
    # basic computations
    gate_list = [sI,sX,sY,sZ]
    gate_list_id = [0,1,2,3]

    temp = [p for p in itertools.product(gate_list_id, repeat=N)]
    #print('temp', temp)

    kk = 0.0
    tampon = 0.0
    for i in range(0,len(temp)):

        gate = gate_list[temp[i][0]]
        for j in range(1,len(temp[i])):
            gate = np.kron(gate,gate_list[temp[i][j]])


        theta =  (2.0**(-N))*(np.conjugate(np.transpose(psi)) @ gate @ psi)**(2.0)
        #print('theta=',i,theta)

        kk = kk + theta

        tampon = tampon + theta**alpha

    #print('normalization =', kk)

    value_numerical = (1.0/(1.0-alpha))*np.log(tampon) - N*np.log(2.0)
    print('numerical value=', N,value_numerical)










"""



fig = plt.figure()
grid = plt.GridSpec(1, 1, wspace=0.4, hspace=0.3)

# TOP 
ax = fig.add_subplot(grid[0, :1])
ax.plot(x,y,color='red',label=r' our result ')
ax.plot(xhamma,yhamma,color='blue',label=r' hamma result ')




ax.set_xlabel(r' $N$',fontsize=30)
ax.set_ylabel(r' $ G $ ',fontsize=30)
ax.grid(True,alpha=0.2)
ax.tick_params( which='major',bottom=True,top=True,left=True,right=True,labeltop=False,labelbottom=True,labelsize='18')
ax.legend(ncol=1,loc='best',fontsize='15')
#ax.set_xscale('log')
#ax.set_yscale('log')

ax.set_xlim([0,5.0])
#ax.set_ylim([0,3])
plt.show()  