(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    172497,       5487]
NotebookOptionsPosition[    144471,       4800]
NotebookOutlinePosition[    144841,       4816]
CellTagsIndexPosition[    144798,       4813]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Jovan", "Section",
 CellChangeTimes->{{3.862027867209474*^9, 
  3.8620278704564905`*^9}},ExpressionUUID->"c4321e12-55d6-46b2-a1e0-\
845b8f7754ec"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f0", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f2", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "2"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f3", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "3"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f4", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "4"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.861191693724984*^9, 3.861191783969883*^9}, {
  3.8611918243284073`*^9, 3.8611918244882174`*^9}, {3.861191958345859*^9, 
  3.861191983373056*^9}, {3.861249750294818*^9, 3.861249789811648*^9}, {
  3.861252411184613*^9, 
  3.86125242332332*^9}},ExpressionUUID->"999f034d-a0a1-4e51-bbd0-\
245d23c6c310"],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 2}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 4},ExpressionUUID->"01d56c2e-34cb-44b5-8b5f-c76affe7f0a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"totalformula", "[", "NN_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    RowBox[{
     SuperscriptBox["2", "NN"], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["2", 
         RowBox[{
          SuperscriptBox["2", 
           RowBox[{"2", "*", "NN"}]], "*", 
          SuperscriptBox["NN", "4"]}]], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["NN", "4"], "*", 
           RowBox[{"f0", "[", "NN", "]"}]}], "-", 
          RowBox[{"8", "*", 
           SuperscriptBox["NN", "3"], "*", 
           RowBox[{"f1", "[", "NN", "]"}]}], "+", 
          RowBox[{"24", "*", 
           SuperscriptBox["NN", "2"], "*", 
           RowBox[{"f2", "[", "NN", "]"}]}], "-", 
          RowBox[{"32", "*", "NN", "*", 
           RowBox[{"f3", "[", "NN", "]"}]}], "+", 
          RowBox[{"16", "*", 
           RowBox[{"f4", "[", "NN", "]"}]}]}], ")"}]}], " ", "+", 
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{"2", "-", "NN"}]], "*", 
        FractionBox[
         RowBox[{"NN", "-", "1"}], 
         SuperscriptBox["NN", "3"]]}]}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.861192650770595*^9, 3.861192661637384*^9}, {
  3.861192707489028*^9, 3.861192708416057*^9}, {3.8611930964451237`*^9, 
  3.861193107302837*^9}, {3.861249853313983*^9, 3.861250036723548*^9}, {
  3.861251097086032*^9, 3.861251105244769*^9}, {3.861251393208267*^9, 
  3.861251395586217*^9}, {3.8612561855315943`*^9, 3.861256186390978*^9}, {
  3.861697841682148*^9, 
  3.8616978419538937`*^9}},ExpressionUUID->"7cf1d2d7-658d-41bd-99c8-\
1f0659b5219d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Marco", "Section",
 CellChangeTimes->{{3.8620278799213624`*^9, 
  3.8620278807838936`*^9}},ExpressionUUID->"80386d80-cdc1-4fa0-922d-\
6862b54adc23"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox["2", "zz"]], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         SuperscriptBox["zz", "4"]], " ", 
        RowBox[{"Sum", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"zz", "-", 
               RowBox[{"2", "k"}]}], ")"}], "4"], 
            RowBox[{"(", 
             RowBox[{"zz", "!"}], ")"}]}], 
           RowBox[{
            RowBox[{"k", "!"}], "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"zz", "-", "k"}], ")"}], "!"}]}]], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "0", ",", "zz"}], "}"}]}], "]"}]}], "+", " ", 
       RowBox[{
        FractionBox[
         SuperscriptBox["2", "4"], 
         SuperscriptBox["zz", "4"]], " ", "2", " ", 
        FractionBox[
         RowBox[{" ", 
          RowBox[{"zz", " ", 
           RowBox[{"(", 
            RowBox[{"zz", "-", "1"}], ")"}]}]}], "2"], 
        RowBox[{"Sum", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{"zz", "-", "2"}], ")"}], "!"}], 
           RowBox[{
            RowBox[{"k", "!"}], "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"zz", "-", "2", "-", "k"}], ")"}], "!"}]}]], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "0", ",", 
            RowBox[{"zz", "-", "2"}]}], "}"}]}], "]"}]}]}], ")"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.8620277619640903`*^9, 
  3.862027768188629*^9}},ExpressionUUID->"4e13a728-d4ca-4ab8-b68f-\
5fba83615023"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{
     RowBox[{"-", "6"}], "+", 
     RowBox[{"7", " ", "zz"}]}], 
    SuperscriptBox["zz", "3"]], "]"}]}]], "Output",
 CellChangeTimes->{{3.862027757618056*^9, 3.8620277690279694`*^9}, 
   3.862027897775937*^9},ExpressionUUID->"b354c60f-8e8b-4e31-a89f-\
fc19fa14403c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"M", "[", "zz_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "6"}], "+", 
      RowBox[{"7", " ", "zz"}]}], 
     SuperscriptBox["zz", "3"]], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8620278060966144`*^9, 3.862027812436228*^9}, 
   3.8620279018316917`*^9},ExpressionUUID->"daf3f84e-3ba0-4496-b944-\
573043c6c4c4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kk", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "x"}], "+", "1"}], ",", 
      RowBox[{"N", "[", 
       RowBox[{"totalformula", "[", 
        RowBox[{
         RowBox[{"2", " ", "x"}], "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "1", ",", "20"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.861194093958446*^9, 3.86119414453008*^9}, {
   3.861250081369543*^9, 3.861250096697475*^9}, {3.861251417035903*^9, 
   3.861251441463594*^9}, {3.8612524033404016`*^9, 3.861252403580378*^9}, {
   3.861253017518852*^9, 3.86125308736379*^9}, {3.861255504661201*^9, 
   3.86125553900882*^9}, 3.861255575056134*^9, {3.861345016606028*^9, 
   3.861345017450951*^9}, {3.861345462854706*^9, 3.861345464265324*^9}, {
   3.861954856507368*^9, 3.861954863210825*^9}, {3.861954897483431*^9, 
   3.861954901802628*^9}, 3.8620266890844603`*^9, {3.862027919240034*^9, 
   3.8620279689393744`*^9}},ExpressionUUID->"29a53c5e-2eb5-40d9-b4de-\
39fd41a51b29"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "0.5877866649021191`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "1.4610179073158271`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "2.0765303314723775`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "2.548622464174108`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "2.931005941353796`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "3.252196815894294`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", "3.5290307531720404`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"17", ",", "3.7722522134563077`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"19", ",", "3.98912985104073`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"21", ",", "4.184807422792101`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"23", ",", "4.363057530868202`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"25", ",", "4.526728759681529`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"27", ",", "4.678024445171566`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"29", ",", "4.8186837612214335`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"31", ",", "4.950103479979372`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"33", ",", "5.073422282195021`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"35", ",", "5.18958063253673`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"37", ",", "5.299364249205153`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"39", ",", "5.40343627998869`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"41", ",", "5.502361530779178`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.862027959346569*^9, 
  3.8620279695295115`*^9}},ExpressionUUID->"a46a843d-eb26-41d4-baa7-\
1b99e6557be4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kk1", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "x"}], "+", "1"}], ",", 
      RowBox[{"N", "[", 
       RowBox[{"M", "[", 
        RowBox[{
         RowBox[{"2", " ", "x"}], "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "1", ",", "20"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8620279908571634`*^9, 
  3.86202799598908*^9}},ExpressionUUID->"5327e70e-cd64-497c-a12f-\
cca8bbf60a95"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "0.5877866649021191`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "1.4610179073158271`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "2.0765303314723775`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "2.548622464174108`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "2.931005941353796`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "3.252196815894294`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", "3.5290307531720404`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"17", ",", "3.7722522134563077`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"19", ",", "3.98912985104073`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"21", ",", "4.184807422792101`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"23", ",", "4.363057530868202`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"25", ",", "4.526728759681529`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"27", ",", "4.678024445171566`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"29", ",", "4.8186837612214335`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"31", ",", "4.950103479979372`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"33", ",", "5.073422282195021`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"35", ",", "5.18958063253673`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"37", ",", "5.299364249205153`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"39", ",", "5.40343627998869`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"41", ",", "5.502361530779178`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.862027996479432*^9},ExpressionUUID->"8f2d2178-a28f-4b59-a134-\
bf0997e57bf6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"kk", ",", "kk1"}], "}"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", "None"}], "}"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"False", ",", "True"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.861250103484765*^9, 3.861250107556403*^9}, {
   3.86125142688494*^9, 3.86125143607259*^9}, {3.861252925708166*^9, 
   3.861252990129279*^9}, {3.861253045845179*^9, 3.861253046859104*^9}, {
   3.861253488667573*^9, 3.861253551981433*^9}, {3.861254312398736*^9, 
   3.861254312753693*^9}, {3.861254385907072*^9, 3.861254410171731*^9}, {
   3.861255438253673*^9, 3.861255535268503*^9}, 3.8612555693556004`*^9, {
   3.861256200851403*^9, 3.861256209099468*^9}, {3.861344938837297*^9, 
   3.861344961946607*^9}, {3.861344996055431*^9, 3.8613449970209837`*^9}, {
   3.8616978740343847`*^9, 3.861697883996779*^9}, {3.861954879242742*^9, 
   3.861954884170656*^9}, {3.8620280056212482`*^9, 
   3.8620280396964307`*^9}},ExpressionUUID->"57da98d1-2a7f-44a1-8e69-\
b2594d4e699f"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, {}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], LineBox[CompressedData["

1:eJxTTMoPSmViYGAQAWIQDQEcDkc+3vilev6RPYQv4hC7WicgJOE7lC/jUDTb
7P3uOQwOEL6SQ96V1TpTklmgfDWHwB/GdpuL2KF8LYcHcYsP17NwQfl6Duzz
dleWWPNA+YYO28o7Jk7S5YPyjR0Y9/q+3POSH8o3dXhzxljDbq8AlG/u8G5K
WdTRYkEo39Kh5vimE3HSQlC+tQPHLHcun20wvq1D7k0DzlA3YSjf3oHH3/Lt
8zNQfoODg7TvZ1N9bxEo39GB7+yjHMVDML6Tw7+t67t6jEShfGcHTs+iNLm5
ML6Lg9WdpfzZTGIOAG2qT3E=
       "]]}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      GeometricTransformationBox[InsetBox[
        FormBox[
         StyleBox[
          GraphicsBox[
           {EdgeForm[None], DiskBox[{0, 0}]}],
          StripOnInput->False,
          GraphicsBoxOptions->{DefaultBaseStyle->Directive[
            PointSize[0.012833333333333334`], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[1.6]]}],
         TraditionalForm], {0., 0.}, Automatic, Offset[
        6.272]], CompressedData["
1:eJxTTMoPSmVmYGAQAWJGIGZigAEOhyMfb/xSPf/IHsIXcYhdrRMQkvAdypdx
KJpt9n73HAYHCF/JIe/Kap0pySxQvppD4A9ju81F7FC+lsODuMWH61m4oHw9
B/Z5uytLrHmgfEOHbeUdEyfp8kH5xg6Me31f7nnJD+WbOrw5Y6xht1cAyjd3
eDelLOposSCUb+lQc3zTiThpISjf2oFjljuXzzYY39Yh96YBZ6ibMJRv78Dj
b/n2+Rkov8HBQdr3s6m+twiU7+jAd/ZRjuIhGN/J4d/W9V09RqJQvrMDp2dR
mtxcGN/FwerOUv5sJjEHAHdCT3M=
       "]]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, {}, {}, {}}, {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6]}, {}, {}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->{648., Automatic},
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 41.}, {0, 5.502361530779178}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.861697884637753*^9, 3.861777277420135*^9, {3.861954884751759*^9, 
   3.861954903757894*^9}, 3.862025357439192*^9, 3.8620266914405375`*^9, 
   3.862027050488489*^9, {3.8620280257737875`*^9, 
   3.862028040190973*^9}},ExpressionUUID->"5e8e3cf9-ec4d-4b4d-bbd0-\
0ea2647cd791"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"5d734c1a-a44f-4857-b70e-8f40871b91d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Jovan W kink state massage to the W state magic?", "Title",
 CellChangeTimes->{{3.86773090057874*^9, 
  3.86773092439918*^9}},ExpressionUUID->"cf742e8f-2a82-4ee3-83a0-\
ecaf4093ff06"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f0", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f2", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "2"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f3", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "3"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"f4", "[", "NN_", "]"}], ":=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "4"], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"f0new", "[", "NN_", "]"}], ":=", 
    RowBox[{
     SuperscriptBox["2", "NN"], "-", "1"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"totalformula", "[", "NN_", "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"Log", "[", 
     RowBox[{
      SuperscriptBox["2", "NN"], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["2", 
          RowBox[{
           SuperscriptBox["2", 
            RowBox[{"2", "*", "NN"}]], "*", 
           SuperscriptBox["NN", "4"]}]], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["NN", "4"], "*", 
            RowBox[{"f0", "[", "NN", "]"}]}], "-", 
           RowBox[{"8", "*", 
            SuperscriptBox["NN", "3"], "*", 
            RowBox[{"f1", "[", "NN", "]"}]}], "+", 
           RowBox[{"24", "*", 
            SuperscriptBox["NN", "2"], "*", 
            RowBox[{"f2", "[", "NN", "]"}]}], "-", 
           RowBox[{"32", "*", "NN", "*", 
            RowBox[{"f3", "[", "NN", "]"}]}], "+", 
           RowBox[{"16", "*", 
            RowBox[{"f4", "[", "NN", "]"}]}]}], ")"}]}], " ", "+", 
        RowBox[{
         SuperscriptBox["2", 
          RowBox[{"2", "-", "NN"}]], "*", 
         FractionBox[
          RowBox[{"NN", "-", "1"}], 
          SuperscriptBox["NN", "3"]]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"totalformulanew", "[", "NN_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    RowBox[{
     SuperscriptBox["2", "NN"], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["2", 
         RowBox[{
          SuperscriptBox["2", 
           RowBox[{"2", "*", "NN"}]], "*", 
          SuperscriptBox["NN", "4"]}]], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["NN", "4"], "*", 
           RowBox[{"f0new", "[", "NN", "]"}]}], "-", 
          RowBox[{"8", "*", 
           SuperscriptBox["NN", "3"], "*", 
           RowBox[{"f1", "[", "NN", "]"}]}], "+", 
          RowBox[{"24", "*", 
           SuperscriptBox["NN", "2"], "*", 
           RowBox[{"f2", "[", "NN", "]"}]}], "-", 
          RowBox[{"32", "*", "NN", "*", 
           RowBox[{"f3", "[", "NN", "]"}]}], "+", 
          RowBox[{"16", "*", 
           RowBox[{"f4", "[", "NN", "]"}]}]}], ")"}]}], " ", "+", 
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{"2", "-", "NN"}]], "*", 
        FractionBox[
         RowBox[{"NN", "-", "1"}], 
         SuperscriptBox["NN", "3"]]}]}], ")"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.867730941475296*^9, 3.867730960352605*^9}, {
  3.8677313841794567`*^9, 
  3.867731470900524*^9}},ExpressionUUID->"bf381daf-c953-4ef9-8d87-\
1317af8a4188"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"totalformula", "[", "3", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.867731415125907*^9, 3.867731417986556*^9}, {
  3.867731480019335*^9, 
  3.867731480414693*^9}},ExpressionUUID->"ed6529c7-79a4-46ae-9e0a-\
45cb397878eb"],

Cell[BoxData["0.5877866649021191`"], "Output",
 CellChangeTimes->{{3.867731420181816*^9, 
  3.867731480651849*^9}},ExpressionUUID->"d57c76f3-9b75-4c26-9187-\
3453d68b18ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"totalformulanew", "[", "3", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.867731426658559*^9, 3.867731426930717*^9}, {
  3.867731482307623*^9, 
  3.867731482626297*^9}},ExpressionUUID->"9a764de5-bd2e-4ca0-a04e-\
b98bb99e3be7"],

Cell[BoxData[
 RowBox[{"-", "0.26662866325394863`"}]], "Output",
 CellChangeTimes->{{3.867731427433673*^9, 
  3.867731483318729*^9}},ExpressionUUID->"c1714b18-b53c-4485-aa57-\
163a53c97d3c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f0", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.86773149725148*^9, 
  3.867731499903058*^9}},ExpressionUUID->"2a06f681-e074-408a-9b2a-\
89c0b56912ea"],

Cell[BoxData["16"], "Output",
 CellChangeTimes->{
  3.867731500916431*^9},ExpressionUUID->"19d6515a-be46-45c7-bc63-\
d000edff173a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f0new", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.867731502975812*^9, 
  3.8677315061460857`*^9}},ExpressionUUID->"8486fac4-90da-439a-bbc6-\
07b2608be6a8"],

Cell[BoxData["31"], "Output",
 CellChangeTimes->{
  3.867731506363535*^9},ExpressionUUID->"2a5e8e9d-3b85-4526-b033-\
a0c466a15e0b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8677341165815697`*^9, 
  3.867734120211076*^9}},ExpressionUUID->"3fabb1e5-ef4d-40a2-90e6-\
5b578c6eed43"],

Cell[BoxData[
 SuperscriptBox["2", 
  RowBox[{
   RowBox[{"-", "1"}], "+", "NN"}]]], "Output",
 CellChangeTimes->{{3.867734114248763*^9, 
  3.867734120764489*^9}},ExpressionUUID->"8016c33c-d1db-4eb3-b28e-\
4cbfee05881b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"0", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "0"}], "]"}]}], "+", 
  RowBox[{"1", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "1"}], "]"}]}], "+", 
  RowBox[{"2", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "2"}], "]"}]}], "+", 
  RowBox[{"3", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "3"}], "]"}]}], "+", 
  RowBox[{"4", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "4"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8677343544519043`*^9, 3.867734372129127*^9}, {
  3.8677360793010893`*^9, 
  3.867736090624895*^9}},ExpressionUUID->"7503a00a-36af-4b64-9dfa-\
66b80df7f4a0"],

Cell[BoxData["837"], "Output",
 CellChangeTimes->{3.867734373849292*^9, 
  3.867736091318111*^9},ExpressionUUID->"73c3e80e-9643-475e-b7a0-\
ea1b18500395"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 SuperscriptBox["2", 
  RowBox[{
   RowBox[{"-", "1"}], "+", "9"}]]], "Input",
 CellChangeTimes->{{3.8677343778589773`*^9, 
  3.8677343832043962`*^9}},ExpressionUUID->"a0da0494-daf9-4d08-817c-\
f90fc1ab3eba"],

Cell[BoxData["256"], "Output",
 CellChangeTimes->{
  3.86773438373628*^9},ExpressionUUID->"88d69087-91d8-40e5-9bfb-5487afc6b2df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
   RowBox[{"0", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "0"}], "]"}]}], "+", 
   RowBox[{"1", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "1"}], "]"}]}], "+", 
   RowBox[{"2", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "2"}], "]"}]}], "+", 
   RowBox[{"3", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "3"}], "]"}]}], "+", 
   RowBox[{"4", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "4"}], "]"}]}], "+", 
   RowBox[{"5", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "5"}], "]"}]}], "+", 
   RowBox[{"6", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "6"}], "]"}]}], "+", 
   RowBox[{"7", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "7"}], "]"}]}], "+", 
   RowBox[{"8", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "8"}], "]"}]}], "+", 
   RowBox[{"9", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"9", ",", "9"}], "]"}]}]}], ")"}]], "Input",
 CellChangeTimes->{{3.867734391059498*^9, 3.8677344082439938`*^9}, {
  3.8677361017361794`*^9, 
  3.867736152788788*^9}},ExpressionUUID->"872f5eb1-bd49-4351-bea8-\
305e9b6527dd"],

Cell[BoxData["2304"], "Output",
 CellChangeTimes->{
  3.867734408886656*^9, {3.867736128456107*^9, 
   3.8677361532361097`*^9}},ExpressionUUID->"e6c16efc-7c17-4f82-8136-\
4097b18ad85f"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "NN_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"x", "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1re", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "NN"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.867735564965947*^9, 3.8677355863079233`*^9}, {
   3.867735629713353*^9, 3.8677356335408373`*^9}, 3.867735750609695*^9, {
   3.8677359427426558`*^9, 3.8677359438287773`*^9}, {3.86773609474288*^9, 
   3.867736095270163*^9}, {3.867736264262054*^9, 3.867736271621101*^9}, {
   3.867737613065518*^9, 3.867737644371175*^9}, {3.8677376845030327`*^9, 
   3.867737692150185*^9}},ExpressionUUID->"08586ce1-e669-41d8-b5ff-\
a662a11e2800"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f0", "[", "7", "]"}]], "Input",
 CellChangeTimes->{{3.867740172932398*^9, 
  3.867740175718151*^9}},ExpressionUUID->"8620d64d-251e-42a2-a66d-\
a58cb94b46b1"],

Cell[BoxData["64"], "Output",
 CellChangeTimes->{
  3.867740176449243*^9},ExpressionUUID->"1695180e-a7a7-4a73-8e21-\
79ee5dd8c67d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1", "[", "7", "]"}]], "Input",
 CellChangeTimes->{{3.8677355909839354`*^9, 3.867735592484074*^9}, {
  3.867736005428815*^9, 3.867736005572649*^9}, {3.867736234565597*^9, 
  3.8677362346764927`*^9}, {3.8677401609352713`*^9, 
  3.867740161091028*^9}},ExpressionUUID->"3600af1d-9275-4980-ace9-\
27c22ba77a29"],

Cell[BoxData["154"], "Output",
 CellChangeTimes->{
  3.867735593474753*^9, 3.86773563582062*^9, 3.8677357530720387`*^9, 
   3.8677359461104107`*^9, {3.8677360068100452`*^9, 3.8677360222029953`*^9}, 
   3.8677360978034163`*^9, {3.867736234928203*^9, 3.867736273246543*^9}, 
   3.867736763442696*^9, {3.867737625513433*^9, 3.867737646175828*^9}, {
   3.867737687213813*^9, 3.867737694912367*^9}, 
   3.867740161351804*^9},ExpressionUUID->"85b5c43d-affb-41f4-8c63-\
72a40e6db3ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1re", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.867735595741535*^9, 3.867735599092083*^9}, {
  3.867736008085457*^9, 3.867736020065621*^9}, {3.867736765781848*^9, 
  3.8677367662764597`*^9}},ExpressionUUID->"2ecf0e0f-95f0-4b8b-b5fb-\
e626ac8fd477"],

Cell[BoxData["80"], "Output",
 CellChangeTimes->{
  3.867735599330456*^9, 3.867735636767086*^9, 3.867735754776804*^9, 
   3.8677359472754097`*^9, {3.867736008712006*^9, 3.867736023190433*^9}, {
   3.867736268211047*^9, 3.867736274299556*^9}, {3.867736764739891*^9, 
   3.867736766471388*^9}, 
   3.8677376267982817`*^9},ExpressionUUID->"89745dcc-aab4-4c9a-bbc6-\
c709fc0c50bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"9", ",", "0"}], "]"}]], "Input",ExpressionUUID->"6b1eddf4-507e-\
4577-9398-6ecc90761803"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.867736160477932*^9},ExpressionUUID->"3167eafd-7c4d-420e-8747-\
16f09e94f720"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"9", ",", "9"}], "]"}]], "Input",
 CellChangeTimes->{{3.86773616221237*^9, 
  3.8677361629165773`*^9}},ExpressionUUID->"f1692dcf-887b-4b12-951b-\
29bff924c79a"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.867736163268495*^9},ExpressionUUID->"d605f047-7bfa-4854-bbe7-\
2de2f658aa65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"9", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{
  3.8677361766791153`*^9},ExpressionUUID->"8b481b49-4d19-4826-9607-\
194826a74408"],

Cell[BoxData["126"], "Output",
 CellChangeTimes->{
  3.867736178766405*^9},ExpressionUUID->"1c9c57cc-e8ca-483d-83e7-\
ffb20147c78d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"9", ",", "5"}], "]"}]], "Input",
 CellChangeTimes->{{3.867736182916601*^9, 
  3.867736183012251*^9}},ExpressionUUID->"4e2fe4a6-ac56-425a-add6-\
0ecc4e5a2f66"],

Cell[BoxData["126"], "Output",
 CellChangeTimes->{
  3.8677361832620373`*^9},ExpressionUUID->"1b29f100-31c4-40ab-9fa1-\
9d7e554ce43d"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"c8a7edc5-930b-4f79-a98f-7b99260e5783"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"0", "*", 
  RowBox[{"Binomial", "[", 
   RowBox[{"5", ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.867736218628193*^9, 3.8677362249167213`*^9}, {
  3.8677362877191267`*^9, 3.867736292773012*^9}, {3.867736336439559*^9, 
  3.86773634656485*^9}},ExpressionUUID->"5bd50b56-1c25-45c0-b5db-\
5f31da2e6dfd"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.867736231054216*^9, 3.867736293130269*^9, {3.8677363376392612`*^9, 
   3.867736347153513*^9}},ExpressionUUID->"b91ea4d3-7db6-4379-ba24-\
3bf587d1cbcc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "*", 
  RowBox[{"Binomial", "[", 
   RowBox[{"5", ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8677363518132133`*^9, 
  3.8677363541169443`*^9}},ExpressionUUID->"89eece29-c1c2-4b60-8a23-\
9dfb72dbc892"],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{
  3.867736354917965*^9},ExpressionUUID->"ddfa1d8f-27ef-4d2e-aed8-\
586665e5ea96"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"2", "*", 
  RowBox[{"Binomial", "[", 
   RowBox[{"5", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8677363577484217`*^9, 
  3.867736360196764*^9}},ExpressionUUID->"f8b0f76e-4686-42a2-a2c2-\
5c258d97a310"],

Cell[BoxData["20"], "Output",
 CellChangeTimes->{{3.867736358196007*^9, 
  3.867736360578662*^9}},ExpressionUUID->"82e2de8e-7d32-406b-a3fe-\
ee52166f873a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"3", "*", 
  RowBox[{"Binomial", "[", 
   RowBox[{"5", ",", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8677363887402554`*^9, 
  3.867736391700377*^9}},ExpressionUUID->"86f16cab-5f57-467a-bba2-\
d109fb71ad66"],

Cell[BoxData["30"], "Output",
 CellChangeTimes->{
  3.867736392268786*^9},ExpressionUUID->"6b9adc3e-735c-4404-b985-\
a650fcc6c465"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "*", 
  RowBox[{"Binomial", "[", 
   RowBox[{"5", ",", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.867736404980381*^9, 
  3.867736408778448*^9}},ExpressionUUID->"3a4116d1-bbf0-4127-8830-\
2ea4fde23792"],

Cell[BoxData["20"], "Output",
 CellChangeTimes->{
  3.867736409153672*^9},ExpressionUUID->"e4297d56-8c11-4fc1-9b13-\
68dde4ebd8ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"5", "*", 
  RowBox[{"Binomial", "[", 
   RowBox[{"5", ",", "5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.867736418740127*^9, 
  3.867736421122591*^9}},ExpressionUUID->"29d5eef0-1530-4095-affc-\
d4d5f239cb18"],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{
  3.86773642158536*^9},ExpressionUUID->"a9b16af9-970b-4911-8272-ea6258e1dc4c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"NN", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ss", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"x", "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"ss1", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"x", "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "NN"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.867736318580821*^9, 3.867736329376829*^9}, {
  3.867736367805345*^9, 
  3.8677363784328814`*^9}},ExpressionUUID->"eceaca51-01fb-4f84-9e05-\
e70029617dba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "5", ",", "20"}], "}"}]], "Output",
 CellChangeTimes->{
  3.867736379006469*^9},ExpressionUUID->"0d451315-fcfd-4c84-8003-\
1d43fc0be8a9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "5", ",", "20", ",", "30", ",", "20", ",", "5"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.8677363790086327`*^9},ExpressionUUID->"db782478-9d1f-4c22-999b-\
278c47bba417"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["ss"], "Input",
 CellChangeTimes->{{3.867736330276827*^9, 
  3.867736330404986*^9}},ExpressionUUID->"93a03767-1b20-4544-bf79-\
0d5e961d92bb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "5", ",", "20"}], "}"}]], "Output",
 CellChangeTimes->{
  3.867736331592882*^9},ExpressionUUID->"b3ef6b6d-e531-4de7-a622-\
a62db656eaf9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], ")"}],
   "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.867740585779448*^9, 
  3.867740588392015*^9}},ExpressionUUID->"78db203b-2954-4be0-a1d2-\
aac3da2399ce"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "4"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["2", "NN"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "-", 
    FractionBox[
     RowBox[{"NN", " ", 
      RowBox[{"Gamma", "[", "NN", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "NN", "-", 
        RowBox[{"2", " ", 
         RowBox[{"Hypergeometric2F1", "[", 
          RowBox[{"1", ",", 
           FractionBox[
            RowBox[{"3", "-", "NN"}], "2"], ",", 
           FractionBox[
            RowBox[{"5", "+", "NN"}], "2"], ",", 
           RowBox[{"-", "1"}]}], "]"}]}]}], ")"}]}], 
     RowBox[{
      RowBox[{"Gamma", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "]"}], " ", 
      RowBox[{"Gamma", "[", 
       FractionBox[
        RowBox[{"5", "+", "NN"}], "2"], "]"}]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.867740571559601*^9, 
  3.867740590637385*^9}},ExpressionUUID->"ab57b526-13ba-4eb0-90c3-\
66ca5c557532"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"NN", "-", 
         RowBox[{"2", "*", "x"}]}], ")"}], "4"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], ")"}],
   "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8677407747748938`*^9, 3.8677407749187107`*^9}, {
  3.867741527603963*^9, 
  3.867741562535368*^9}},ExpressionUUID->"c6748bf6-4bb8-4a83-b899-\
97ff3fe9b8bb"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "NN"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "-", 
    RowBox[{"4", " ", "NN"}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["NN", "2"]}], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", "NN"}]}], ")"}], " ", 
      RowBox[{"Gamma", "[", 
       FractionBox["NN", "2"], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Hypergeometric2F1Regularized", "[", 
          RowBox[{"2", ",", 
           FractionBox[
            RowBox[{"3", "-", "NN"}], "2"], ",", 
           FractionBox[
            RowBox[{"5", "+", "NN"}], "2"], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3"}], "+", "NN"}], ")"}], " ", 
         RowBox[{"Hypergeometric2F1Regularized", "[", 
          RowBox[{"3", ",", 
           FractionBox[
            RowBox[{"5", "-", "NN"}], "2"], ",", 
           FractionBox[
            RowBox[{"7", "+", "NN"}], "2"], ",", 
           RowBox[{"-", "1"}]}], "]"}]}]}], ")"}]}], 
     SqrtBox["\[Pi]"]]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.86774077598317*^9, {3.867741557424135*^9, 
   3.867741572567531*^9}},ExpressionUUID->"93953b59-25fc-4ae4-9199-\
f8f2781ead6b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Hypergeometric2F1", "[", 
    RowBox[{"1", ",", 
     FractionBox[
      RowBox[{"3", "-", "NN"}], "2"], ",", 
     FractionBox[
      RowBox[{"5", "+", "NN"}], "2"], ",", 
     RowBox[{"-", "1"}]}], "]"}], " ", ",", 
   RowBox[{"{", 
    RowBox[{"NN", ",", "1", ",", "105"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8677409694441833`*^9, 3.8677409856232357`*^9}, {
  3.8677410242314377`*^9, 
  3.8677410641370363`*^9}},ExpressionUUID->"a23182c3-1688-4f52-9d5e-\
45861854341f"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw1lHs4lekaxheWciqWtdY3CEkOOaRIDjl89+qAyinLYa2l9g5pFMmhPdgI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       "]]},
     Annotation[#, "Charting`Private`Tag$39153#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.7725889829290867},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{592.7999999999995, Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{1, 105}, {0.7725889829290867, 5.677335333642279}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.867741058139813*^9, 
  3.867741064594349*^9}},ExpressionUUID->"564df0f5-ef28-4c06-8c69-\
18af2ca0d658"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Hypergeometric2F1Regularized", "[", 
  RowBox[{"2", ",", 
   FractionBox[
    RowBox[{"3", "-", "NN"}], "2"], ",", 
   FractionBox[
    RowBox[{"5", "+", "NN"}], "2"], ",", 
   RowBox[{"-", "1"}]}], "]"}]], "Input",ExpressionUUID->"bc625642-07b1-4733-\
b58f-697a121be5af"],

Cell[BoxData[
 RowBox[{"Hypergeometric2F1Regularized", "[", 
  RowBox[{"2", ",", 
   FractionBox[
    RowBox[{"3", "-", "NN"}], "2"], ",", 
   FractionBox[
    RowBox[{"5", "+", "NN"}], "2"], ",", 
   RowBox[{"-", "1"}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.867741637619369*^9},ExpressionUUID->"58ef18a1-cb47-4ec1-a1ab-\
5762b7c21fd9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"x", "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], ",", 
    
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{
      RowBox[{"NN", "\[Element]", "PositiveIntegers"}], "&&", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"NN", ",", "2"}], "]"}], "\[Equal]", "1"}]}]}]}], "]"}], 
  "\n"}]], "Input",
 CellChangeTimes->{{3.867744010146723*^9, 
  3.8677440577180347`*^9}},ExpressionUUID->"8cf153db-c53d-4d14-9fae-\
4eefd6077680"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["2", "NN"], " ", "NN"}], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "NN"}], ")"}], " ", 
      SqrtBox["\[Pi]"], " ", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", 
        FractionBox[
         RowBox[{"1", "+", "NN"}], "2"]}], "]"}], " ", 
      RowBox[{"Gamma", "[", 
       FractionBox[
        RowBox[{"3", "+", "NN"}], "2"], "]"}]}], 
     RowBox[{"NN", " ", 
      RowBox[{"Gamma", "[", 
       FractionBox["NN", "2"], "]"}]}]], "-", 
    RowBox[{"2", " ", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       FractionBox[
        RowBox[{"3", "+", "NN"}], "2"]}], "]"}], " ", 
     RowBox[{"Hypergeometric2F1", "[", 
      RowBox[{"2", ",", 
       FractionBox[
        RowBox[{"3", "-", "NN"}], "2"], ",", 
       FractionBox[
        RowBox[{"5", "+", "NN"}], "2"], ",", 
       RowBox[{"-", "1"}]}], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.867744040085197*^9, 
  3.867744064328964*^9}},ExpressionUUID->"873122cf-7392-4cbe-8825-\
22b4684b2dd3"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"1555ef18-152e-45c3-96a5-77d07c99b426"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"x", "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{
      RowBox[{"NN", "\[Element]", "PositiveIntegers"}], "&&", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"NN", ",", "2"}], "]"}], "\[Equal]", "1"}]}]}]}], "]"}], "//",
   "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8677444570007753`*^9, 3.867744460055047*^9}, {
  3.867744502660982*^9, 3.867744504389254*^9}, {3.867744535417918*^9, 
  3.86774453562607*^9}},ExpressionUUID->"5d6f04d2-811e-4541-b990-\
956f073295b8"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "4"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["2", "NN"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "-", 
    FractionBox[
     RowBox[{"NN", " ", 
      RowBox[{"Gamma", "[", "NN", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "NN", "-", 
        RowBox[{"2", " ", 
         RowBox[{"Hypergeometric2F1", "[", 
          RowBox[{"1", ",", 
           FractionBox[
            RowBox[{"3", "-", "NN"}], "2"], ",", 
           FractionBox[
            RowBox[{"5", "+", "NN"}], "2"], ",", 
           RowBox[{"-", "1"}]}], "]"}]}]}], ")"}]}], 
     RowBox[{
      RowBox[{"Gamma", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "]"}], " ", 
      RowBox[{"Gamma", "[", 
       FractionBox[
        RowBox[{"5", "+", "NN"}], "2"], "]"}]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.867744460434136*^9, 3.867744506980053*^9, 
  3.8677445411267643`*^9},ExpressionUUID->"7c3ba9ca-24d1-4736-9f83-\
ca2248dadedf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["x", "2"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{
      RowBox[{"NN", "\[Element]", "PositiveIntegers"}], "&&", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"NN", ",", "2"}], "]"}], "\[Equal]", "1"}]}]}]}], "]"}], "//",
   "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8677444897205467`*^9, 3.86774450890818*^9}, {
  3.867744555386619*^9, 
  3.867744557509384*^9}},ExpressionUUID->"53ab55cd-f2d6-4185-86e1-\
e264aa795d72"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", 
   RowBox[{
    RowBox[{"-", "3"}], "+", "NN"}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    SuperscriptBox["NN", "2"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    FractionBox[
     RowBox[{
      RowBox[{"Gamma", "[", 
       RowBox[{"1", "+", 
        FractionBox["NN", "2"]}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "-", "NN", "+", 
        RowBox[{"Hypergeometric2F1", "[", 
         RowBox[{"1", ",", 
          FractionBox[
           RowBox[{"3", "-", "NN"}], "2"], ",", 
          FractionBox[
           RowBox[{"5", "+", "NN"}], "2"], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ")"}]}], 
     RowBox[{
      SqrtBox["\[Pi]"], " ", 
      RowBox[{"Gamma", "[", 
       FractionBox[
        RowBox[{"5", "+", "NN"}], "2"], "]"}]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.8677444909049683`*^9, 3.867744513855482*^9}, 
   3.8677445638375387`*^9},ExpressionUUID->"0a293960-0a4e-47df-9db0-\
17a351a697ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["x", "3"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{
      RowBox[{"NN", "\[Element]", "PositiveIntegers"}], "&&", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"NN", ",", "2"}], "]"}], "\[Equal]", "1"}]}]}]}], "]"}], "//",
   "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8677445707886143`*^9, 
  3.867744570919879*^9}},ExpressionUUID->"2236f95c-3a83-4dd9-8715-\
59d6321f219f"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", 
   RowBox[{
    RowBox[{"-", "4"}], "+", "NN"}]], " ", 
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{"2", " ", "NN"}], "+", 
    SuperscriptBox["NN", "3"], "+", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"3", " ", "NN"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         RowBox[{"Gamma", "[", 
          RowBox[{"1", "+", 
           FractionBox["NN", "2"]}], "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["2", 
          RowBox[{"-", "NN"}]], " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"Gamma", "[", 
          RowBox[{"2", "+", "NN"}], "]"}], " ", 
         RowBox[{"Hypergeometric2F1Regularized", "[", 
          RowBox[{"1", ",", 
           FractionBox[
            RowBox[{"3", "-", "NN"}], "2"], ",", 
           FractionBox[
            RowBox[{"5", "+", "NN"}], "2"], ",", 
           RowBox[{"-", "1"}]}], "]"}]}]}], ")"}]}], 
     RowBox[{
      SqrtBox["\[Pi]"], " ", 
      RowBox[{"Gamma", "[", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "]"}]}]]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{
  3.867744584284011*^9},ExpressionUUID->"a9836688-074f-4a8d-ac2b-\
9bfafb6fae65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["x", "4"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{
      RowBox[{"NN", "\[Element]", "PositiveIntegers"}], "&&", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"NN", ",", "2"}], "]"}], "\[Equal]", "1"}]}]}]}], "]"}], "//",
   "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.867744605256193*^9, 
  3.867744605528132*^9}},ExpressionUUID->"de820768-0343-4919-87d3-\
cdef7a121ec3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{
     RowBox[{"-", "5"}], "+", "NN"}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", 
     RowBox[{"NN", " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", "NN"}], ")"}]}]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["4", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "NN"}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"NN", " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", "NN"}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"Gamma", "[", 
      RowBox[{"1", "+", 
       FractionBox["NN", "2"]}], "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"3", "+", "NN", "-", 
      RowBox[{"2", " ", 
       RowBox[{"Hypergeometric2F1", "[", 
        RowBox[{"1", ",", 
         FractionBox[
          RowBox[{"3", "-", "NN"}], "2"], ",", 
         FractionBox[
          RowBox[{"5", "+", "NN"}], "2"], ",", 
         RowBox[{"-", "1"}]}], "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", "NN"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"3", "+", "NN"}], ")"}], " ", "\[Pi]", " ", 
    RowBox[{"Gamma", "[", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "NN"}], "]"}]}]]}]], "Output",
 CellChangeTimes->{
  3.8677446199401293`*^9},ExpressionUUID->"86b66daf-8e85-478c-805c-\
dbf6391efb79"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"NN", ",", 
     RowBox[{"Hypergeometric2F1", "[", 
      RowBox[{"1", ",", 
       FractionBox[
        RowBox[{"3", "-", "NN"}], "2"], ",", 
       FractionBox[
        RowBox[{"5", "+", "NN"}], "2"], ",", 
       RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"NN", ",", "3", ",", "15", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.867744948063939*^9, 
  3.867744985256916*^9}},ExpressionUUID->"ae057de2-afce-47d2-affc-\
af637ff4259d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     FractionBox["6", "5"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     FractionBox["29", "21"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", 
     FractionBox["65", "42"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", 
     FractionBox["281", "165"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", 
     FractionBox["2380", "1287"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", 
     FractionBox["9949", "5005"]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.867744956398439*^9, 
  3.867744985826527*^9}},ExpressionUUID->"6e1134fb-a516-4476-8a0c-\
85c98f23c732"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "]"}], " ", 
   RowBox[{"Gamma", "[", 
    FractionBox[
     RowBox[{"5", "+", "NN"}], "2"], "]"}]}], "//", "FullSimplify"}]], "Input",\

 CellChangeTimes->{{3.8677450273688307`*^9, 
  3.867745031716421*^9}},ExpressionUUID->"2434fef2-612b-45e7-9f9d-\
2682da1b5c7d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"Gamma", "[", "NN", "]"}], 
   RowBox[{
    RowBox[{"Gamma", "[", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "]"}], " ", 
    RowBox[{"Gamma", "[", 
     FractionBox[
      RowBox[{"5", "+", "NN"}], "2"], "]"}]}]], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.867745047542739*^9, 
  3.8677450739447813`*^9}},ExpressionUUID->"6e592bf5-e948-4a1a-818e-\
eb62316cdb57"],

Cell[BoxData[
 FractionBox[
  RowBox[{"Gamma", "[", "NN", "]"}], 
  RowBox[{
   RowBox[{"Gamma", "[", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "NN"}], ")"}]}], "]"}], " ", 
   RowBox[{"Gamma", "[", 
    FractionBox[
     RowBox[{"5", "+", "NN"}], "2"], "]"}]}]]], "Output",
 CellChangeTimes->{{3.867745059291368*^9, 
  3.8677450742855787`*^9}},ExpressionUUID->"a4afc4ea-7e05-4cff-95d6-\
7f47d64793e1"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 2}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 4},ExpressionUUID->"daedfe64-6965-483f-8988-7c34a9940b09"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"(", GridBox[{
      {"0", 
       RowBox[{"-", "I"}]},
      {"I", "0"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zero", "=", 
   RowBox[{"(", GridBox[{
      {"1"},
      {"0"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"one", "=", 
   RowBox[{"(", GridBox[{
      {"0"},
      {"1"}
     }], ")"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8677467833175383`*^9, 3.867746789702375*^9}, {
  3.867746823353177*^9, 
  3.867746849224984*^9}},ExpressionUUID->"62197eb8-8153-426a-b11e-\
3c3e259f6b43"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"m", ".", "zero"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.867746851950986*^9, 
  3.867746858853623*^9}},ExpressionUUID->"c1f226d5-b698-4ab6-a59d-\
7dd537a93637"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"\[ImaginaryI]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.867746854649015*^9, 
  3.867746859156129*^9}},ExpressionUUID->"112077bc-1ce0-4b9c-928d-\
6b5201153920"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"m", ".", "one"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.86774688177229*^9, 
  3.867746883592018*^9}},ExpressionUUID->"d7e054d1-23d3-4d42-8ad4-\
ab9f0b4402d5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.867746884113723*^9},ExpressionUUID->"eb6e45ac-a41b-423e-a03d-\
76cfa1b4d846"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hadamard", "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"Sqrt", "[", "2", "]"}]], "*", 
    RowBox[{"(", GridBox[{
       {"1", "1"},
       {"1", 
        RowBox[{"-", "1"}]}
      }], ")"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.867749347237365*^9, 
  3.867749374742743*^9}},ExpressionUUID->"2de03b10-1e31-43e9-af89-\
f77af36ee588"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kk", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"KroneckerProduct", "[", 
     RowBox[{"Hadamard", ",", 
      RowBox[{"KroneckerProduct", "[", 
       RowBox[{"Hadamard", ",", "Hadamard"}], "]"}]}], "]"}], "*", "2", "*", 
    RowBox[{"Sqrt", "[", "2", "]"}]}], "//", "MatrixForm"}]}]], "Input",
 CellChangeTimes->{{3.867749376970186*^9, 
  3.8677494627306747`*^9}},ExpressionUUID->"3d68ae70-a2de-4c50-bac2-\
f4de7f509666"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", "1", "1", "1", "1", "1"},
     {"1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}]},
     {"1", "1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], "1", "1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}]},
     {"1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], "1", "1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], "1"},
     {"1", "1", "1", "1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}]},
     {"1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1"},
     {"1", "1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], "1", "1"},
     {"1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1", "1", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.867749413570096*^9, 
  3.867749463569829*^9}},ExpressionUUID->"89899439-7c75-478f-88d2-\
a1f438a95429"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"left", "=", 
  RowBox[{
   RowBox[{"KroneckerProduct", "[", 
    RowBox[{"one", ",", 
     RowBox[{"KroneckerProduct", "[", 
      RowBox[{"one", ",", "one"}], "]"}]}], "]"}], "//", 
   "MatrixForm"}]}]], "Input",
 CellChangeTimes->{{3.8677495005380898`*^9, 
  3.867749511659368*^9}},ExpressionUUID->"15f10657-f334-4958-903c-\
3217f411afd8"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.867749501906913*^9, 
  3.8677495120182867`*^9}},ExpressionUUID->"a6251f33-4192-4468-9d5b-\
944a3a3d0e23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kk", ".", "left"}]], "Input",
 CellChangeTimes->{{3.867749468999896*^9, 
  3.867749530680163*^9}},ExpressionUUID->"5264a4e1-266e-443d-96c3-\
c0883af61c8d"],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"1", "1", "1", "1", "1", "1", "1", "1"},
      {"1", 
       RowBox[{"-", "1"}], "1", 
       RowBox[{"-", "1"}], "1", 
       RowBox[{"-", "1"}], "1", 
       RowBox[{"-", "1"}]},
      {"1", "1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "1", "1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}]},
      {"1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "1", "1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "1"},
      {"1", "1", "1", "1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}]},
      {"1", 
       RowBox[{"-", "1"}], "1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "1", 
       RowBox[{"-", "1"}], "1"},
      {"1", "1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "1", "1"},
      {"1", 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "1", 
       RowBox[{"-", "1"}], "1", "1", 
       RowBox[{"-", "1"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], ".", 
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]}]], "Output",
 CellChangeTimes->{{3.8677494915962257`*^9, 
  3.867749541754806*^9}},ExpressionUUID->"fbcc0947-ae76-4df5-9611-\
25ef22f13233"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"ed9983e5-c96e-42b7-995d-da8b9e973e42"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f1explicit", "[", "NN_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "NN"}], "}"}]}], "]"}], "-", 
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{"NN", "-", "1"}], "2"], ")"}], "*", 
    RowBox[{"(", 
     FractionBox[
      RowBox[{"NN", "-", "1"}], "2"], ")"}]}], "-", 
   RowBox[{"Sum", "[", 
    RowBox[{"x", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], "+", "1"}]}], 
      "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.86781584545356*^9, 
  3.867816090727569*^9}},ExpressionUUID->"4f2fc513-1045-474a-9488-\
44869c40e6fd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.867815924674312*^9, 
  3.8678159269672337`*^9}},ExpressionUUID->"f03575d9-4361-4775-949a-\
300b3084f554"],

Cell[BoxData["25"], "Output",
 CellChangeTimes->{{3.867815927362535*^9, 3.8678159403773403`*^9}, {
  3.8678160486709948`*^9, 
  3.8678160930762587`*^9}},ExpressionUUID->"ea2245a9-f247-4578-9478-\
0c4d8591f54c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1explicit", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.867815928563776*^9, 
  3.8678159316742563`*^9}},ExpressionUUID->"0b336564-3be7-40b0-b094-\
6fec4475b0c2"],

Cell[BoxData["70"], "Output",
 CellChangeTimes->{{3.8678159318978577`*^9, 3.8678159412775097`*^9}, {
  3.867816049546225*^9, 
  3.867816094059651*^9}},ExpressionUUID->"824391f4-6e52-484d-8f9b-\
6f1a86999c8e"]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.867816414635166*^9},ExpressionUUID->"d00db88b-0743-42ad-b138-\
046c53ad037c"],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 2}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 4},ExpressionUUID->"dc31b617-5ebd-4fe8-9d34-55964d2df339"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f0", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "NN"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f0explicit", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], "+", 
    
    RowBox[{"NN", "*", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"2", "*", "x"}], "-", "1"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "1", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
    "+", "1"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.867816880844887*^9, 
  3.8678169455132732`*^9}},ExpressionUUID->"51d9c049-5e6d-4f4a-b869-\
8843f86505c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f0", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867816934582823*^9, 3.8678169366805773`*^9}, {
  3.8678169832084913`*^9, 3.8678169833046293`*^9}, {3.867817030889804*^9, 
  3.8678170359161243`*^9}},ExpressionUUID->"cb9b5044-d845-4319-a4f1-\
517a630969d7"],

Cell[BoxData["2048"], "Output",
 CellChangeTimes->{{3.867816936948908*^9, 3.867816948285377*^9}, 
   3.867816984036553*^9, {3.867817031522464*^9, 
   3.8678170367302237`*^9}},ExpressionUUID->"faa9b7a7-3247-434d-83ce-\
038c2d7fe21b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f0explicit", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867816938479228*^9, 3.8678169418840017`*^9}, {
  3.867816985820448*^9, 3.8678169859634867`*^9}, {3.867817032908649*^9, 
  3.867817038315918*^9}},ExpressionUUID->"af6f0520-0a4f-41e5-af53-\
0278cd82f98a"],

Cell[BoxData["1300"], "Output",
 CellChangeTimes->{{3.8678169420907288`*^9, 3.867816949229848*^9}, 
   3.8678169861601353`*^9, {3.867817033432007*^9, 
   3.867817038497457*^9}},ExpressionUUID->"04bec5d6-5e8f-4b31-bbf9-\
856bf6f174e4"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"98a34093-d9d5-4c4a-9366-67f07dbed2c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"1", "+", "x", "+", 
   FractionBox[
    RowBox[{"x", "*", 
     RowBox[{"(", 
      RowBox[{"x", "-", "1"}], ")"}]}], 
    RowBox[{"2", "!"}]], "+", 
   FractionBox[
    RowBox[{"x", "*", 
     RowBox[{"(", 
      RowBox[{"x", "-", "1"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"x", "-", "2"}], ")"}]}], 
    RowBox[{"3", "!"}]], "+", 
   FractionBox[
    RowBox[{"x", "*", 
     RowBox[{"(", 
      RowBox[{"x", "-", "1"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"x", "-", "2"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"x", "-", "3"}], ")"}]}], 
    RowBox[{"4", "!"}]]}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.867817674706846*^9, 
  3.8678177386845427`*^9}},ExpressionUUID->"0f72347b-259e-42a8-9819-\
ceff6b24127e"],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{
   FractionBox["1", "24"], " ", "x", " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", "x"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"14", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", "x"}], ")"}], " ", "x"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.867817729250448*^9, 
  3.867817739180057*^9}},ExpressionUUID->"3cec143a-bd35-4fde-8df2-\
d04d672d1f08"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"c73c68e9-b128-4899-b1f2-95cd5ef4778d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "NN"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8678183110213947`*^9, 
  3.867818427308917*^9}},ExpressionUUID->"cffdc75e-eed9-42c9-b41a-\
b188eb06871c"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", 
   RowBox[{
    RowBox[{"-", "1"}], "+", "NN"}]], " ", "NN"}]], "Output",
 CellChangeTimes->{{3.867818320579035*^9, 
  3.867818427807086*^9}},ExpressionUUID->"ad232fef-6faf-4153-85de-\
860e627ad919"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"NN", "-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.867818432029093*^9, 
  3.8678184321093683`*^9}},ExpressionUUID->"a8b6185a-a7d9-46bf-91fb-\
03c224ed743d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "NN"}], "+", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}]], " ", "NN"}]}]], "Output",
 CellChangeTimes->{
  3.867818433262393*^9},ExpressionUUID->"0d4f446b-4dd4-4386-88d0-\
19ca06e80fec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"NN", "-", "2"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8678184377735*^9, 
  3.8678184378680487`*^9}},ExpressionUUID->"cb2347a1-b233-4f29-be4f-\
3dd86cbb7740"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "NN"}], "+", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}]], " ", "NN"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN"}]}]], "Output",
 CellChangeTimes->{
  3.867818438869293*^9},ExpressionUUID->"32ac05bc-ffca-4ce1-85af-\
19c481d8fd26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"NN", "-", "3"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.867818441371827*^9, 
  3.867818441485549*^9}},ExpressionUUID->"ad81e92b-a294-4f41-b509-\
ac724fa02a3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "NN"}], "+", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}]], " ", "NN"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN"}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "NN"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN"}]}]], "Output",
 CellChangeTimes->{
  3.867818441804117*^9},ExpressionUUID->"da78de81-7168-46e8-9efb-\
780c74d55f84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"x", "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"NN", "-", "4"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.867818446653512*^9, 
  3.86781844674962*^9}},ExpressionUUID->"3aca6a55-9967-4eaf-b143-\
5edaaa77dd0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "NN"}], "+", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}]], " ", "NN"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN"}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "NN"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN"}], "-", 
  RowBox[{
   FractionBox["1", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "+", "NN"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2"}], "+", "NN"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "NN"}], ")"}], " ", "NN"}]}]], "Output",
 CellChangeTimes->{
  3.867818447211864*^9},ExpressionUUID->"ee0822b6-ba87-4d1e-bde4-\
c7129751458c"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"733a7c9b-fee6-489f-9fd8-cf6826422920"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"b7be657d-8033-4bd8-8c90-2f35a8f6eefb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f1test", "[", "NN_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{"NN", "-", "1"}]], "*", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["NN", "2"], "-", "1"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.867820040526557*^9, 
  3.867820072127223*^9}},ExpressionUUID->"4131e1aa-d216-4465-b6b6-\
86b74f6a23df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1", "[", "3", "]"}]], "Input",
 CellChangeTimes->{{3.867820074125596*^9, 
  3.867820119746222*^9}},ExpressionUUID->"ebac73ce-8ce1-4da7-821b-\
3d5cc71b1367"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{{3.867820075750387*^9, 
  3.867820120171191*^9}},ExpressionUUID->"b39b5811-0479-4f92-8d80-\
071b1dbc7d92"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1test", "[", "3", "]"}]], "Input",
 CellChangeTimes->{{3.867820077034977*^9, 
  3.867820122430831*^9}},ExpressionUUID->"64d42e50-e862-4c6a-bfdf-\
4a6281867be3"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{{3.8678200800754423`*^9, 
  3.8678201226890717`*^9}},ExpressionUUID->"f9c5ef24-2418-4d1b-a20d-\
3a6e17a88c36"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"1eb175b3-aaeb-46f2-9893-df2e5db1033d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tt", "[", "x_", "]"}], ":=", 
   RowBox[{"Binomial", "[", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"x", "+", "1"}], ")"}], "/", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ttt", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{"x", "-", "2"}], 
      RowBox[{"x", "+", "1"}]], ")"}], "*", 
    SuperscriptBox["2", "x"]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.867821782791112*^9, 
  3.867821871505416*^9}},ExpressionUUID->"12e04753-5a87-4acc-b9a9-\
291693363378"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tt", "[", "6", "]"}]], "Input",
 CellChangeTimes->{{3.867821872761372*^9, 3.8678218860331*^9}, {
  3.867821944801819*^9, 
  3.867821944928914*^9}},ExpressionUUID->"06b34ea7-9392-473a-8a1a-\
be308ac44186"],

Cell[BoxData[
 FractionBox["2048", 
  RowBox[{"35", " ", "\[Pi]"}]]], "Output",
 CellChangeTimes->{{3.867821874654855*^9, 3.8678218865626783`*^9}, 
   3.867821945257286*^9},ExpressionUUID->"f55f0fa7-cdc1-4e47-92b9-\
1513a17fda97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ttt", "[", "6", "]"}]], "Input",
 CellChangeTimes->{{3.867821875253519*^9, 3.8678218885413733`*^9}, {
  3.8678219475975723`*^9, 
  3.8678219477282867`*^9}},ExpressionUUID->"bb5d36db-70fe-4c1e-835e-\
87b6a090ca18"],

Cell[BoxData[
 FractionBox["256", "7"]], "Output",
 CellChangeTimes->{{3.8678218774599953`*^9, 3.86782188916956*^9}, 
   3.867821948112755*^9},ExpressionUUID->"125efa0e-7213-4dc9-9c5c-\
21c9c3494e02"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"f76108d3-65ef-4f75-a873-30d0ebde199f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f1", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"x", "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f11", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"NN", "*", 
     SuperscriptBox["2", 
      RowBox[{"NN", "-", "2"}]]}], "-", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "+", "1"}], ")"}], "/", "4"}], ")"}]}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.867823304466984*^9, 3.867823353730277*^9}, {
   3.86782569578185*^9, 3.867825700884386*^9}, {3.867825736342958*^9, 
   3.867825816181396*^9}, 3.867825876502577*^9, {3.867825933990416*^9, 
   3.867825936194359*^9}, {3.8678260040220633`*^9, 3.867826010213036*^9}, {
   3.8678260781020803`*^9, 
   3.867826097956655*^9}},ExpressionUUID->"69cbf9c7-eb28-4f97-a06a-\
b90ac9d1854f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867823355901373*^9, 3.867823384177904*^9}, {
  3.8678270742933807`*^9, 
  3.867827083509296*^9}},ExpressionUUID->"21f5a979-cf1e-42df-92f0-\
e2ff09fc6cd8"],

Cell[BoxData["4246"], "Output",
 CellChangeTimes->{{3.867823358494823*^9, 3.867823384401161*^9}, 
   3.867825703719055*^9, 3.8678257798191566`*^9, 3.86782581963485*^9, 
   3.867825878931089*^9, 3.867825938239873*^9, 3.867826011964855*^9, 
   3.867826101260778*^9, {3.867827072063993*^9, 
   3.8678270837803097`*^9}},ExpressionUUID->"1250b40b-7e6a-4237-8abb-\
888071242664"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f11", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867823359865005*^9, 3.867823386335958*^9}, 
   3.867825707736375*^9, {3.867827076758295*^9, 
   3.867827085621544*^9}},ExpressionUUID->"3a8c94bd-5cda-43f1-b7ff-\
b261daaea413"],

Cell[BoxData["4246"], "Output",
 CellChangeTimes->{{3.867823361919339*^9, 3.8678233865906878`*^9}, {
   3.867825704959634*^9, 3.867825708279104*^9}, 3.86782578088024*^9, 
   3.86782582065302*^9, 3.86782588014217*^9, 3.867825939097568*^9, 
   3.8678260129153147`*^9, 3.867826102306962*^9, {3.867827073243959*^9, 
   3.86782708596563*^9}},ExpressionUUID->"1c5ce5f8-6a2f-47b3-a9e6-\
c0dae9322643"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"ea739c68-dcab-4e71-bc4c-2c5c3afec17f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Binomial", "[", 
   RowBox[{"9", ",", "1"}], "]"}], "+", 
  RowBox[{"2", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "2"}], "]"}]}], "+", 
  RowBox[{"3", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "3"}], "]"}]}], "+", 
  RowBox[{"4", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "4"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8678235443541822`*^9, 3.867823582049313*^9}, {
  3.867823641075267*^9, 
  3.8678236479545383`*^9}},ExpressionUUID->"26b1ce96-4088-4cdf-b4fd-\
9f7555be2a7c"],

Cell[BoxData["837"], "Output",
 CellChangeTimes->{
  3.867823585236817*^9, {3.867823621835659*^9, 
   3.867823648392703*^9}},ExpressionUUID->"04be7ad9-8e29-4ae2-bae1-\
85fbd1dc26bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867823592582398*^9, 3.867823595294467*^9}, {
  3.8678240522282667`*^9, 
  3.86782405249787*^9}},ExpressionUUID->"d75db835-397b-462a-afaf-\
797b3fc9bd25"],

Cell[BoxData["4246"], "Output",
 CellChangeTimes->{{3.867823595516327*^9, 3.867823650085642*^9}, 
   3.8678240527939*^9},ExpressionUUID->"513188b3-22cd-4eba-9cf0-436824c9397f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"9", "+", 
  RowBox[{"9", "*", "8"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "2"}], ")"}], "*", "9", "*", "8", "*", "7"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "6"}], ")"}], "*", "9", "*", "8", "*", "7", "*", 
   "6"}]}]], "Input",
 CellChangeTimes->{{3.867823685730535*^9, 
  3.867823714686412*^9}},ExpressionUUID->"2a6d7ca2-633a-4380-a918-\
3e8f954bbe5d"],

Cell[BoxData["837"], "Output",
 CellChangeTimes->{
  3.867823715373188*^9},ExpressionUUID->"bdb92896-2f3a-4810-b56c-\
381b0b6427dd"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f111", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"NN", "-", "x"}], ")"}], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], "-", "1"}], 
        ")"}]}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1111", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "x"}], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "}"}]}], 
     "]"}], "-", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}], "*", 
     RowBox[{"(", 
      RowBox[{"NN", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], ")"}]}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.867824002579383*^9, 3.867824024035976*^9}, {
  3.867824122900222*^9, 3.867824127075247*^9}, {3.8678244007244787`*^9, 
  3.86782446350347*^9}, {3.8678249446315937`*^9, 3.867824949806381*^9}, {
  3.867825430438518*^9, 
  3.8678254561163607`*^9}},ExpressionUUID->"c0a203ea-78f1-48e2-b862-\
fd53df49909f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f111", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867824026130641*^9, 
  3.8678240554431334`*^9}},ExpressionUUID->"494556db-3567-4ae0-9c8d-\
94c94b0fa113"],

Cell[BoxData["4246"], "Output",
 CellChangeTimes->{{3.867824029299704*^9, 3.8678240557067738`*^9}, 
   3.8678241304562483`*^9, {3.867824451270156*^9, 3.867824465933588*^9}, 
   3.8678249525046873`*^9, {3.8678254479010887`*^9, 
   3.867825457537936*^9}},ExpressionUUID->"695f2295-ae46-4b62-931a-\
cfb3f50cd000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f1111", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.867824454787734*^9, 
  3.86782447358991*^9}},ExpressionUUID->"db1153c6-614b-4e5f-a33b-\
140664ac1697"],

Cell[BoxData["4246"], "Output",
 CellChangeTimes->{{3.8678244556258583`*^9, 3.867824474140386*^9}, 
   3.867824953739887*^9, {3.8678254489971037`*^9, 
   3.867825458596957*^9}},ExpressionUUID->"557534e5-1bd7-4c0d-ba97-\
64de03e6523e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"zz", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"NN", "-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.867825380131872*^9, 
  3.8678253848842077`*^9}},ExpressionUUID->"e83070c0-da20-42ac-8386-\
d69e425731ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"zz", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.8678253883286867`*^9, 
  3.8678253909467163`*^9}},ExpressionUUID->"f5775b00-73dc-48f3-894c-\
d62f2dbf3415"],

Cell[BoxData["630"], "Output",
 CellChangeTimes->{
  3.867825392181657*^9},ExpressionUUID->"41e41357-a83f-48b6-a746-\
86c402877b9e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{"9", "*", "8", "*", "7", "*", "6", "*", "5"}], "24"]], "Input",
 CellChangeTimes->{{3.86782539939373*^9, 
  3.8678254077320223`*^9}},ExpressionUUID->"1897d745-c1cf-487b-8825-\
a5339d6f40ac"],

Cell[BoxData["630"], "Output",
 CellChangeTimes->{
  3.8678254081827507`*^9},ExpressionUUID->"9be4e5bc-4920-4132-bc05-\
9036c81d8534"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", "x"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.867825973494879*^9, 
  3.867825979940114*^9}},ExpressionUUID->"c2526a79-bc42-4d9e-93ae-\
943b9a43697e"],

Cell[BoxData[
 SuperscriptBox["2", 
  RowBox[{
   RowBox[{"-", "1"}], "+", "NN"}]]], "Output",
 CellChangeTimes->{{3.867825973806658*^9, 
  3.867825980240531*^9}},ExpressionUUID->"e6919728-3df2-4c71-8487-\
a460c1f96811"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"x", ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"x", "-", "1"}], ")"}], "/", "2"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.867826146084601*^9, 
  3.867826153415434*^9}},ExpressionUUID->"ce017c6e-7da7-4c08-ab12-\
abcc198293c9"],

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{"x", ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "x"}], ")"}]}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.867826153805654*^9},ExpressionUUID->"ac68356d-af19-48a0-a3dd-\
1b77cdb395e2"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"6f6d131b-06a2-4052-9ded-c9d7e8765a8d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f2", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "2"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f22", "[", "NN_", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", "+", "1"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"NN", "-", "x"}], ")"}], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], "-", "1"}], 
       ")"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f222", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "+", "1"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{"NN", "-", "x"}], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"(", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
       "}"}]}], "]"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NN", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], " ", "+", " ", 
       "1"}], ")"}], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f2222", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "+", "1"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{"NN", "-", "x"}], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"(", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
       "}"}]}], "]"}], "-", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "+", "1"}], ")"}], "/", "2"}], ")"}], "2"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f22222", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       RowBox[{"NN", "-", "1"}], "2"], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
       RowBox[{
        FractionBox["1", "2"], "*", 
        FractionBox[
         RowBox[{"NN", "+", "1"}], "2"], "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     FractionBox["1", "2"], "*", 
     SuperscriptBox["2", 
      RowBox[{"NN", "-", "1"}]], "*", "NN"}], "-", 
    RowBox[{
     FractionBox["1", "2"], "*", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "+", "1"}], ")"}], "/", "2"}], ")"}], "2"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.8678281050145903`*^9, 3.86782817696782*^9}, 
   3.867828340490776*^9, {3.867828544072715*^9, 3.8678285441514273`*^9}, {
   3.867829282953817*^9, 3.867829350163583*^9}, {3.867829520618692*^9, 
   3.867829521064506*^9}, {3.8678309504926577`*^9, 3.867830960935038*^9}, {
   3.867831529635005*^9, 3.867831546986793*^9}, {3.8678316099397297`*^9, 
   3.867831621980255*^9}, {3.867832425674136*^9, 3.867832487164968*^9}, {
   3.867832546092732*^9, 3.8678325462660427`*^9}, {3.867834138542541*^9, 
   3.8678341735331793`*^9}, {3.867834586942696*^9, 
   3.867834688524979*^9}},ExpressionUUID->"f17a6510-5298-48f5-a9b9-\
fd66322e8c13"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f2", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.867828146283176*^9, 3.867828148742351*^9}, {
  3.867828184279274*^9, 3.867828184514372*^9}, {3.867828221203939*^9, 
  3.86782822131804*^9}},ExpressionUUID->"1d343e74-7da2-49eb-b449-\
3285917adf7e"],

Cell[BoxData["2925"], "Output",
 CellChangeTimes->{{3.867828149016432*^9, 3.867828184713834*^9}, 
   3.867828222255143*^9, 3.867828342061194*^9, 3.867828546386073*^9, 
   3.867829336483633*^9, 3.867829526070739*^9, 3.867830964277507*^9, 
   3.8678310762541647`*^9, 3.867831549970355*^9, 3.867831615129342*^9, 
   3.867832478142741*^9, 
   3.867834161367646*^9},ExpressionUUID->"cf9e1f49-56eb-4380-9c5a-\
0d949ba1600d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"0", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "0"}], "]"}]}], "+", 
  RowBox[{"1", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "1"}], "]"}]}], "+", 
  RowBox[{"4", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "2"}], "]"}]}], "+", 
  RowBox[{"9", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "3"}], "]"}]}], "+", 
  RowBox[{"16", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "4"}], "]"}]}], "+", 
  RowBox[{"25", "*", 
   RowBox[{"Binomial", "[", 
    RowBox[{"9", ",", "5"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.867828150005939*^9, 3.8678281519581013`*^9}, {
  3.867828186103684*^9, 3.867828188106097*^9}, {3.8678282235608997`*^9, 
  3.867828223878474*^9}, {3.867828377497974*^9, 3.867828422646242*^9}, {
  3.8678321982319*^9, 
  3.86783220527454*^9}},ExpressionUUID->"9ec4125c-f0d2-4664-b1ac-\
5810e0419f8d"],

Cell[BoxData["6075"], "Output",
 CellChangeTimes->{3.867828188465145*^9, 3.867828224063052*^9, 
  3.8678283430697813`*^9, 3.867828423103454*^9, 3.8678285473423767`*^9, 
  3.8678293383268957`*^9, 3.867830965858832*^9, 3.867832205613187*^9, 
  3.86783247999935*^9},ExpressionUUID->"a9c90ebf-e594-48df-831f-2716205fd6d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"1", "*", "9"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"4", "*", "9", "*", "8"}], ")"}], "/", "2"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"9", "*", "9", "*", "8", "*", "7"}], ")"}], "/", "6"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"16", "*", "9", "*", "8", "*", "7", "*", "6"}], ")"}], "/", 
   "24"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"25", "*", "9", "*", "8", "*", "7", "*", "6", "*", "5"}], ")"}], 
   "/", "120"}]}]], "Input",
 CellChangeTimes->{{3.867831037245633*^9, 3.867831053065301*^9}, {
  3.867831215644127*^9, 3.867831240201597*^9}, {3.867832181655541*^9, 
  3.8678322191785727`*^9}},ExpressionUUID->"bb7438c4-1a00-4759-b5ad-\
987a70d3031d"],

Cell[BoxData["6075"], "Output",
 CellChangeTimes->{{3.86783105402395*^9, 3.867831077999381*^9}, 
   3.867831240972323*^9, {3.8678321941752453`*^9, 3.8678322196694717`*^9}, 
   3.867832481051556*^9},ExpressionUUID->"6fef4ac4-5855-4900-a91a-\
a6704fd0579a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f22", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.867828548707694*^9, 
  3.867828550598671*^9}},ExpressionUUID->"cd14e3e3-77a7-4ae7-8c10-\
24ee8acba898"],

Cell[BoxData["2925"], "Output",
 CellChangeTimes->{
  3.867828550838315*^9, 3.867829339324642*^9, {3.867829524519178*^9, 
   3.867829527151211*^9}, 3.867830967063541*^9, 3.8678315514454393`*^9, {
   3.867831617111878*^9, 3.867831624374151*^9}, 3.867832482060422*^9, 
   3.867832555394808*^9},ExpressionUUID->"9701f11e-15f7-4bfb-8b00-\
4e5f45da2d55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f222", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.867829340892989*^9, 
  3.867829343655222*^9}},ExpressionUUID->"33841943-06e6-46c5-8160-\
5f476106e1a6"],

Cell[BoxData["2925"], "Output",
 CellChangeTimes->{{3.8678293441063766`*^9, 3.8678293523193197`*^9}, {
   3.867829522916642*^9, 3.867829528151188*^9}, {3.867832483446645*^9, 
   3.867832488984357*^9}, {3.867832554034885*^9, 3.867832556342987*^9}, 
   3.867834162825425*^9},ExpressionUUID->"fe54b8bd-1744-44ee-9ba8-\
9c9e330b7d26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f2222", "[", "9", "]"}]], "Input",
 CellChangeTimes->{
  3.8678341671959457`*^9},ExpressionUUID->"6f205060-9722-4c4b-8953-\
85f89e761fbc"],

Cell[BoxData["2925"], "Output",
 CellChangeTimes->{{3.867834168152053*^9, 3.867834176075045*^9}, 
   3.867834694074254*^9},ExpressionUUID->"757502d6-5ca5-43c6-b6e5-\
7be62f5b52f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f22222", "[", "9", "]"}]], "Input",
 CellChangeTimes->{
  3.8678346627221603`*^9},ExpressionUUID->"e532e1a6-3e89-4767-9560-\
5ec3fb6f0bdf"],

Cell[BoxData["2925"], "Output",
 CellChangeTimes->{{3.8678346633859053`*^9, 
  3.867834695034595*^9}},ExpressionUUID->"264299b9-eb39-404d-9d24-\
53a63770f7e3"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ss", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"x", "+", "1"}], ")"}], "2"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", 
        RowBox[{"x", "+", "1"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"(", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
      "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ss1", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", "x", ")"}], "2"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], "+", "1"}], 
        ")"}]}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ss2", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", "x", ")"}], "2"], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "1", ",", 
        RowBox[{"(", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
       "}"}]}], "]"}], "+", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"NN", "-", "1"}], "2"], "+", "1"}], ")"}], "2"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{
        FractionBox[
         RowBox[{"NN", "-", "1"}], "2"], "+", "1"}]}], "]"}]}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.867829953047471*^9, 
  3.867830109256936*^9}},ExpressionUUID->"be301f2b-a712-420e-8fec-\
70c01824755f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ss", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.8678300122277527`*^9, 
  3.867830021496348*^9}},ExpressionUUID->"d26f8d4f-08e7-4b47-ad1c-\
2ff006bb0ae7"],

Cell[BoxData["6075"], "Output",
 CellChangeTimes->{{3.8678300139870157`*^9, 
  3.8678300488759212`*^9}},ExpressionUUID->"64214e31-4846-4b7f-8471-\
f3a9d03619ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ss1", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.867830014882502*^9, 
  3.867830024696136*^9}},ExpressionUUID->"076dc55d-6042-4e8f-ab26-\
9e0003559ca0"],

Cell[BoxData["6075"], "Output",
 CellChangeTimes->{{3.867830018128921*^9, 
  3.867830049711557*^9}},ExpressionUUID->"3786a094-e34f-437d-af68-\
da763f8fe78b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ss2", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.86783007381845*^9, 
  3.867830076552184*^9}},ExpressionUUID->"f7f3a68c-e6b0-4da2-8912-\
49dc581183dd"],

Cell[BoxData["6075"], "Output",
 CellChangeTimes->{3.867830076998362*^9, 
  3.867830111408252*^9},ExpressionUUID->"423b9db3-5c15-4e51-ae60-\
52a74884ceed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{"NN", "-", "1"}], "2"], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
      RowBox[{
       FractionBox["1", "2"], "*", 
       FractionBox[
        RowBox[{"NN", "+", "1"}], "2"], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], "*", 
    SuperscriptBox["2", 
     RowBox[{"NN", "-", "1"}]], "*", "NN"}], "-", 
   RowBox[{
    FractionBox["1", "2"], "*", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "+", "1"}], ")"}], "/", "2"}], ")"}], "2"], "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], "//",
   "Simplify"}]], "Input",
 CellChangeTimes->{{3.867834729357119*^9, 
  3.8678347308822308`*^9}},ExpressionUUID->"54367892-4f73-4efc-8c65-\
0a587a67b16f"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "8"], " ", "NN", " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "NN"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["2", "NN"], "-", 
    RowBox[{"2", " ", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{
  3.8678347313762007`*^9},ExpressionUUID->"492fd23b-d2d3-478b-aa2c-\
3f37df7436e6"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"8a7d290a-9c0f-4227-8c5e-c702f0605b44"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f3", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "3"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f33", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"x", "+", "1"}], ")"}], "2"], "*", 
      RowBox[{"(", 
       RowBox[{"NN", "-", "x"}], ")"}], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], "-", "1"}], 
        ")"}]}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f333", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "+", "1"}], ")"}], "2"], "*", 
       RowBox[{"(", 
        RowBox[{"NN", "-", "x"}], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"(", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
       "}"}]}], "]"}], "-", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "+", "1"}], ")"}], "/", "2"}], ")"}], "3"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f3333", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     FractionBox["1", "16"], "*", "NN", "*", 
     RowBox[{"(", 
      RowBox[{"NN", "+", "1"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"NN", "-", "2"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["2", "NN"], "-", 
       RowBox[{"2", "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        RowBox[{"2", "*", "NN"}], "-", "1"}], "2"], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
       RowBox[{
        FractionBox["1", "2"], "*", 
        RowBox[{"(", 
         FractionBox[
          RowBox[{"NN", "+", "1"}], "2"], ")"}], "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{"NN", "*", 
     SuperscriptBox["2", 
      RowBox[{"NN", "-", "2"}]]}], "-", 
    RowBox[{
     FractionBox["1", "2"], "*", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"NN", "+", "1"}], "2"], ")"}], "3"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f33333", "[", "NN_", "]"}], ":=", 
   RowBox[{
    FractionBox["1", "16"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", "NN"], " ", 
       SuperscriptBox["NN", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", "NN"}], ")"}]}], "-", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", "NN"}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "NN"}]}], ")"}], " ", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.867835935774419*^9, 3.8678359654066772`*^9}, {
  3.867836109995242*^9, 3.867836155390519*^9}, {3.8678367749294252`*^9, 
  3.867836911920389*^9}, {3.867837213601755*^9, 3.8678373530573606`*^9}, {
  3.867837753433621*^9, 3.8678377641442833`*^9}, {3.867837850270216*^9, 
  3.867837858032559*^9}},ExpressionUUID->"4d5d1337-4571-446f-92aa-\
8efc288cd1fc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f3", "[", "91", "]"}]], "Input",
 CellChangeTimes->{{3.86783596633011*^9, 
  3.86783598115202*^9}},ExpressionUUID->"aeae0819-99d4-4a5f-96e4-\
8ef92ed459ea"],

Cell[BoxData["90899464402876746723611715496832"], "Output",
 CellChangeTimes->{{3.867835968634515*^9, 
  3.867835982027287*^9}},ExpressionUUID->"86f6e8f5-222a-4de5-9188-\
ef5563587afb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f33", "[", "91", "]"}]], "Input",
 CellChangeTimes->{{3.8678359694514723`*^9, 
  3.8678359834027777`*^9}},ExpressionUUID->"c24aae0a-3899-4ddc-ba3a-\
f4a91df531fc"],

Cell[BoxData["90899464402876746723611715496832"], "Output",
 CellChangeTimes->{{3.8678359714876127`*^9, 
  3.867835984045504*^9}},ExpressionUUID->"ccfe312e-21b8-415b-9662-\
5c8ddcd0b35a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f333", "[", "91", "]"}]], "Input",
 CellChangeTimes->{{3.867836158712281*^9, 
  3.8678361618981037`*^9}},ExpressionUUID->"5b2066c0-8f4f-433c-bf31-\
121f15fc5a56"],

Cell[BoxData["90899464402876746723611715496832"], "Output",
 CellChangeTimes->{
  3.86783616235462*^9},ExpressionUUID->"778cfcbc-1871-4572-8f73-0c81b728f073"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f3333", "[", "91", "]"}]], "Input",
 CellChangeTimes->{{3.867836914173953*^9, 
  3.86783691791848*^9}},ExpressionUUID->"10e44a9c-6aea-4927-87b9-\
e222c4ab7ac0"],

Cell[BoxData["90899464402876746723611715496832"], "Output",
 CellChangeTimes->{
  3.867836918363604*^9, {3.8678373427358723`*^9, 3.867837354951109*^9}, 
   3.8678377701368017`*^9},ExpressionUUID->"6a6983a8-93e2-4332-97f3-\
f9c5f173dbac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f33333", "[", "91", "]"}]], "Input",
 CellChangeTimes->{{3.867837860345644*^9, 
  3.8678378647010317`*^9}},ExpressionUUID->"a115309d-cb21-4632-922c-\
4839ff475757"],

Cell[BoxData["90899464402876746723611715496832"], "Output",
 CellChangeTimes->{
  3.867837865207676*^9},ExpressionUUID->"99e22863-2c72-4015-a4c4-\
1ecbf0b52163"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", "16"], "*", "NN", "*", 
    RowBox[{"(", 
     RowBox[{"NN", "+", "1"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{"NN", "+", "2"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["2", "NN"], "-", 
      RowBox[{"2", "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "-", 
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       RowBox[{"2", "*", "NN"}], "+", "1"}], "2"], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
      RowBox[{
       FractionBox["1", "2"], "*", 
       RowBox[{"(", 
        FractionBox[
         RowBox[{"NN", "+", "1"}], "2"], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{"NN", "*", 
    SuperscriptBox["2", 
     RowBox[{"NN", "-", "2"}]]}], "-", 
   RowBox[{
    FractionBox["1", "2"], "*", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"NN", "+", "1"}], "2"], ")"}], "3"], "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"d09c3e66-78cb-4075-ad41-056d94aa9e3e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"kk", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"x", "+", "1"}], ")"}], "2"], "*", 
      RowBox[{"(", 
       RowBox[{"NN", "-", "x"}], ")"}], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"(", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
      "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"kk1", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NN", "-", "2"}], ")"}], "*", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["x", "2"], "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"(", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
        "}"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", "*", "NN"}], "-", "1"}], ")"}], "*", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"x", "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"(", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
        "}"}]}], "]"}]}], "+", 
    RowBox[{"NN", "*", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"(", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
        "}"}]}], "]"}]}], "-", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "3"], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"(", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
       "}"}]}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.867837402669333*^9, 3.8678375149130983`*^9}, {
  3.867837620370545*^9, 3.867837627536841*^9}, {3.867837712941319*^9, 
  3.86783771307321*^9}},ExpressionUUID->"ebd371fa-6f43-4fa3-86ba-\
25ade4fa57ec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kk", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.867837408660426*^9, 
  3.867837409759802*^9}},ExpressionUUID->"c1241163-3bdd-4eb9-a931-\
03c38c0bfb77"],

Cell[BoxData["355"], "Output",
 CellChangeTimes->{3.8678374099746723`*^9, 3.867837516901844*^9, 
  3.8678376304660273`*^9, 
  3.867837714854436*^9},ExpressionUUID->"fb326fb3-cff4-4121-a066-\
43b0b77aabab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kk1", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.867837518439994*^9, 
  3.8678375199188766`*^9}},ExpressionUUID->"60a036b5-1375-4539-ba92-\
8ff44a5b9e86"],

Cell[BoxData["355"], "Output",
 CellChangeTimes->{3.8678375201549673`*^9, 3.86783763125471*^9, 
  3.8678377158319397`*^9},ExpressionUUID->"36bb1855-bc5c-4480-ba08-\
a82c055850af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", "16"], "*", "NN", "*", 
    RowBox[{"(", 
     RowBox[{"NN", "+", "1"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{"NN", "-", "2"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["2", "NN"], "-", 
      RowBox[{"2", "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       RowBox[{"2", "*", "NN"}], "-", "1"}], "2"], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
      RowBox[{
       FractionBox["1", "2"], "*", 
       RowBox[{"(", 
        FractionBox[
         RowBox[{"NN", "+", "1"}], "2"], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{"NN", "*", 
    SuperscriptBox["2", 
     RowBox[{"NN", "-", "2"}]]}], "-", 
   RowBox[{
    FractionBox["1", "2"], "*", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"NN", "+", "1"}], "2"], ")"}], "3"], "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], "//",
   "Simplify"}]], "Input",
 CellChangeTimes->{{3.867837778223907*^9, 
  3.8678377859233*^9}},ExpressionUUID->"f57b6143-664e-428c-bb7d-5bff763ac255"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "16"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["2", "NN"], " ", 
     SuperscriptBox["NN", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"3", "+", "NN"}], ")"}]}], "-", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "NN"}], ")"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"3", " ", "NN"}]}], ")"}], " ", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{
  3.8678377863020563`*^9},ExpressionUUID->"01a33469-8c55-4d58-bc80-\
179b9d3f15aa"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"5fa3e198-fef5-4396-9af8-dadc139fa892"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f4", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "4"], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f44", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"x", "+", "1"}], ")"}], "3"], "*", 
      RowBox[{"(", 
       RowBox[{"NN", "-", "x"}], ")"}], "*", 
      RowBox[{"Binomial", "[", 
       RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], "-", "1"}], 
        ")"}]}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f444", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "+", "1"}], ")"}], "3"], "*", 
       RowBox[{"(", 
        RowBox[{"NN", "-", "x"}], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"(", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}], ")"}]}], 
       "}"}]}], "]"}], "-", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "+", "1"}], ")"}], "/", "2"}], ")"}], "4"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f4444", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     FractionBox["1", "32"], "*", 
     RowBox[{"(", 
      RowBox[{"NN", "-", "3"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["2", "NN"], "*", 
        SuperscriptBox["NN", "2"], "*", 
        RowBox[{"(", 
         RowBox[{"NN", "+", "3"}], ")"}]}], "-", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"NN", "+", "1"}], ")"}], "2"], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", "*", "NN"}], "-", "1"}], ")"}], "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     FractionBox["1", "16"], "*", "NN", "*", 
     RowBox[{"(", 
      RowBox[{"NN", "+", "1"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", "*", "NN"}], "-", "3"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["2", "NN"], "-", 
       RowBox[{"2", "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        RowBox[{"3", "*", "NN"}], "-", "1"}], "2"], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
       RowBox[{
        FractionBox["1", "2"], "*", 
        RowBox[{"(", 
         FractionBox[
          RowBox[{"NN", "+", "1"}], "2"], ")"}], "*", 
        RowBox[{"Binomial", "[", 
         RowBox[{"NN", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{"NN", "*", 
     SuperscriptBox["2", 
      RowBox[{"NN", "-", "2"}]]}], "-", 
    RowBox[{
     FractionBox["1", "2"], "*", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"NN", "+", "1"}], "2"], ")"}], "4"], "*", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.867838067087988*^9, 3.8678380838082647`*^9}, {
  3.867838203826433*^9, 3.8678382167832403`*^9}, {3.867838863523293*^9, 
  3.867839026711598*^9}},ExpressionUUID->"e0dc2b5e-d5f8-4736-b76a-\
a478181254a8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f4", "[", "51", "]"}]], "Input",
 CellChangeTimes->{{3.867838086326627*^9, 3.867838088111854*^9}, 
   3.867838227028308*^9},ExpressionUUID->"dfef6795-cf5b-4c2c-9203-\
68b6acebbf45"],

Cell[BoxData["310507175430584165436"], "Output",
 CellChangeTimes->{3.86783808842272*^9, 
  3.867838228270578*^9},ExpressionUUID->"0ac7ce9f-d0fa-452a-81bb-\
b0995edb7a3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f44", "[", "51", "]"}]], "Input",
 CellChangeTimes->{{3.8678380895003633`*^9, 3.8678380913278923`*^9}, 
   3.867838226403178*^9},ExpressionUUID->"5844f1f6-d5bd-4c9e-98f5-\
4b53ef1c8fb9"],

Cell[BoxData["310507175430584165436"], "Output",
 CellChangeTimes->{3.867838091479492*^9, 
  3.867838229026267*^9},ExpressionUUID->"07df6bf4-01da-405a-af8b-\
9744d1e55916"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f444", "[", "51", "]"}]], "Input",
 CellChangeTimes->{{3.8678382210906343`*^9, 
  3.867838225470001*^9}},ExpressionUUID->"dbd01016-915d-463e-b8bf-\
ebd081d317d8"],

Cell[BoxData["310507175430584165436"], "Output",
 CellChangeTimes->{{3.867838223337201*^9, 
  3.8678382301658278`*^9}},ExpressionUUID->"4535b9aa-0a55-43fa-a5fc-\
82a01525d5dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"NN", "-", "j"}], ")"}], "*", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"j", "+", "1"}], ")"}], "3"]}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.86783835635489*^9, 
  3.8678383924368887`*^9}},ExpressionUUID->"aa942bd3-3872-4938-af6f-\
4414ae238fa6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "j"}], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["j", "2"]}], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["j", "3"]}], "-", 
  SuperscriptBox["j", "4"], "+", "NN", "+", 
  RowBox[{"3", " ", "j", " ", "NN"}], "+", 
  RowBox[{"3", " ", 
   SuperscriptBox["j", "2"], " ", "NN"}], "+", 
  RowBox[{
   SuperscriptBox["j", "3"], " ", "NN"}]}]], "Output",
 CellChangeTimes->{{3.867838372710987*^9, 
  3.867838392731443*^9}},ExpressionUUID->"d1689b74-97e2-4e40-b4dd-\
670328a7a3b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f4444", "[", "51", "]"}]], "Input",
 CellChangeTimes->{{3.86783902947539*^9, 
  3.86783903212949*^9}},ExpressionUUID->"888ea8e6-6767-44e4-8314-\
8b38615bc09f"],

Cell[BoxData["310507175430584165436"], "Output",
 CellChangeTimes->{
  3.867839032334238*^9},ExpressionUUID->"01e54e7c-a903-45d7-865d-\
0a3d740f6f87"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", "32"], "*", 
    RowBox[{"(", 
     RowBox[{"NN", "-", "3"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", "NN"], "*", 
       SuperscriptBox["NN", "2"], "*", 
       RowBox[{"(", 
        RowBox[{"NN", "+", "3"}], ")"}]}], "-", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"NN", "+", "1"}], ")"}], "2"], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", "*", "NN"}], "-", "1"}], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "16"], "*", "NN", "*", 
    RowBox[{"(", 
     RowBox[{"NN", "+", "1"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", "*", "NN"}], "-", "3"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["2", "NN"], "-", 
      RowBox[{"2", "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       RowBox[{"3", "*", "NN"}], "-", "1"}], "2"], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"NN", "-", "2"}]], "*", "NN"}], "-", 
      RowBox[{
       FractionBox["1", "2"], "*", 
       RowBox[{"(", 
        FractionBox[
         RowBox[{"NN", "+", "1"}], "2"], ")"}], "*", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], 
     ")"}]}], "+", 
   RowBox[{"NN", "*", 
    SuperscriptBox["2", 
     RowBox[{"NN", "-", "2"}]]}], "-", 
   RowBox[{
    FractionBox["1", "2"], "*", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"NN", "+", "1"}], "2"], ")"}], "4"], "*", 
    RowBox[{"Binomial", "[", 
     RowBox[{"NN", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}]}]}], "//",
   "Simplify"}]], "Input",
 CellChangeTimes->{{3.867839041117202*^9, 
  3.867839042436849*^9}},ExpressionUUID->"03d5abf3-ae5d-413f-a3ee-\
58282c099a22"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "32"], " ", "NN", " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "NN"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["2", "NN"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       RowBox[{"5", " ", "NN"}], "+", 
       SuperscriptBox["NN", "2"]}], ")"}]}], "-", 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", "NN"}], "+", 
       SuperscriptBox["NN", "2"]}], ")"}], " ", 
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{
  3.867839042673225*^9},ExpressionUUID->"b0dbe905-1e95-4c2d-abdc-\
54b5a69b6880"]
}, Open  ]],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 3}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 5},ExpressionUUID->"4f90ee97-89ad-4e69-9797-beb2adc4f402"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f0expl", "[", "NN_", "]"}], ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1expl", "[", "NN_", "]"}], ":=", 
   RowBox[{
    RowBox[{"NN", "*", 
     SuperscriptBox["2", 
      RowBox[{"NN", "-", "2"}]]}], "-", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"NN", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"NN", "-", "1"}], ")"}], "/", "2"}], ")"}]}], "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"NN", "+", "1"}], ")"}], "/", "4"}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f2expl", "[", "NN_", "]"}], ":=", 
   RowBox[{
    FractionBox["1", "8"], " ", "NN", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "NN"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["2", "NN"], "-", 
      RowBox[{"2", " ", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f3expl", "[", "NN_", "]"}], ":=", 
   RowBox[{
    FractionBox["1", "16"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", "NN"], " ", 
       SuperscriptBox["NN", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", "NN"}], ")"}]}], "-", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", "NN"}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "NN"}]}], ")"}], " ", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f4expl", "[", "NN_", "]"}], ":=", 
   RowBox[{
    FractionBox["1", "32"], " ", "NN", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "NN"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["2", "NN"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"5", " ", "NN"}], "+", 
         SuperscriptBox["NN", "2"]}], ")"}]}], "-", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", "NN"}], "+", 
         SuperscriptBox["NN", "2"]}], ")"}], " ", 
       RowBox[{"Binomial", "[", 
        RowBox[{"NN", ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "NN"}], ")"}]}]}], "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"totalformula", "[", "NN_", "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"Log", "[", 
     RowBox[{
      SuperscriptBox["2", "NN"], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["2", 
          RowBox[{
           SuperscriptBox["2", 
            RowBox[{"2", "*", "NN"}]], "*", 
           SuperscriptBox["NN", "4"]}]], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["NN", "4"], "*", 
            RowBox[{"f0expl", "[", "NN", "]"}]}], "-", 
           RowBox[{"8", "*", 
            SuperscriptBox["NN", "3"], "*", 
            RowBox[{"f1expl", "[", "NN", "]"}]}], "+", 
           RowBox[{"24", "*", 
            SuperscriptBox["NN", "2"], "*", 
            RowBox[{"f2expl", "[", "NN", "]"}]}], "-", 
           RowBox[{"32", "*", "NN", "*", 
            RowBox[{"f3expl", "[", "NN", "]"}]}], "+", 
           RowBox[{"16", "*", 
            RowBox[{"f4expl", "[", "NN", "]"}]}]}], ")"}]}], " ", "+", 
        RowBox[{
         SuperscriptBox["2", 
          RowBox[{"2", "-", "NN"}]], "*", 
         FractionBox[
          RowBox[{"NN", "-", "1"}], 
          SuperscriptBox["NN", "3"]]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8678391806734962`*^9, 3.867839192595416*^9}, {
  3.867839253485261*^9, 3.867839358366001*^9}, {3.867839621984524*^9, 
  3.867839633794478*^9}, {3.8678396713336773`*^9, 
  3.8678397179864273`*^9}},ExpressionUUID->"e37b9ea5-c5ed-4344-8cb7-\
51785a9b3f65"],

Cell[BoxData[
 RowBox[{
  RowBox[{"M", "[", "zz_", "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "6"}], "+", 
      RowBox[{"7", " ", "zz"}]}], 
     SuperscriptBox["zz", "3"]], "]"}]}]}]], "Input",ExpressionUUID->\
"3cebd776-1d7f-45c2-9a0c-850757d5ec93"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"totalformula", "[", "7", "]"}]], "Input",
 CellChangeTimes->{{3.867839447198225*^9, 3.867839449937031*^9}, {
   3.86783958720348*^9, 3.867839587280155*^9}, {3.867839659091022*^9, 
   3.8678396595696993`*^9}, 
   3.86783973992337*^9},ExpressionUUID->"ece7e3a4-bb35-4e67-9186-\
49fffef065b9"],

Cell[BoxData[
 RowBox[{"Log", "[", 
  FractionBox["343", "43"], "]"}]], "Output",
 CellChangeTimes->{
  3.86783945029832*^9, 3.867839587602993*^9, {3.8678396399465322`*^9, 
   3.8678397403954887`*^9}},ExpressionUUID->"59dbc123-1798-4060-9d5d-\
7807fa40a961"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M", "[", "7", "]"}]], "Input",
 CellChangeTimes->{{3.867839453084989*^9, 3.867839454817322*^9}, {
  3.867839589731629*^9, 
  3.867839589841662*^9}},ExpressionUUID->"fd3d09f3-63dd-46e1-b01b-\
769b795992ef"],

Cell[BoxData[
 RowBox[{"Log", "[", 
  FractionBox["343", "43"], "]"}]], "Output",
 CellChangeTimes->{3.867839455207904*^9, 3.8678395900913277`*^9, 
  3.867839656783849*^9, 
  3.8678397417851*^9},ExpressionUUID->"e77e613f-28ad-4f84-9088-da454995895a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"totalformula", "[", "NN", "]"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8678397492267*^9, 
  3.867839760513481*^9}},ExpressionUUID->"5b82791f-6265-4f9a-a314-\
2f49e15c192e"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{
     RowBox[{"-", "6"}], "+", 
     RowBox[{"7", " ", "NN"}]}], 
    SuperscriptBox["NN", "3"]], "]"}]}]], "Output",
 CellChangeTimes->{{3.867839754130313*^9, 
  3.867839761280485*^9}},ExpressionUUID->"ea6d3439-15ca-47b2-a555-\
9527b3a40251"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1347, 929},
WindowMargins->{{Automatic, 159}, {Automatic, -117}},
Magnification:>1.25 Inherited,
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 152, 3, 82, "Section", "ExpressionUUID" -> \
"c4321e12-55d6-46b2-a1e0-845b8f7754ec"],
Cell[735, 27, 2404, 78, 168, "Input", "ExpressionUUID" -> \
"999f034d-a0a1-4e51-bbd0-245d23c6c310"],
Cell[3142, 107, 329, 10, 10, "Text", "ExpressionUUID" -> \
"01d56c2e-34cb-44b5-8b5f-c76affe7f0a0"],
Cell[3474, 119, 1657, 43, 69, "Input", "ExpressionUUID" -> \
"7cf1d2d7-658d-41bd-99c8-1f0659b5219d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5168, 167, 154, 3, 82, "Section", "ExpressionUUID" -> \
"80386d80-cdc1-4fa0-922d-6862b54adc23"],
Cell[CellGroupData[{
Cell[5347, 174, 1768, 55, 75, "Input", "ExpressionUUID" -> \
"4e13a728-d4ca-4ab8-b68f-5fba83615023"],
Cell[7118, 231, 348, 10, 63, "Output", "ExpressionUUID" -> \
"b354c60f-8e8b-4e31-a89f-fc19fa14403c"]
}, Open  ]],
Cell[7481, 244, 409, 12, 69, "Input", "ExpressionUUID" -> \
"daf3f84e-3ba0-4496-b944-573043c6c4c4"],
Cell[CellGroupData[{
Cell[7915, 260, 1071, 23, 41, "Input", "ExpressionUUID" -> \
"29a53c5e-2eb5-40d9-b4de-39fd41a51b29"],
Cell[8989, 285, 1720, 45, 70, "Output", "ExpressionUUID" -> \
"a46a843d-eb26-41d4-baa7-1b99e6557be4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10746, 335, 526, 16, 41, "Input", "ExpressionUUID" -> \
"5327e70e-cd64-497c-a12f-cca8bbf60a95"],
Cell[11275, 353, 1694, 45, 70, "Output", "ExpressionUUID" -> \
"8f2d2178-a28f-4b59-a134-bf0997e57bf6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13006, 403, 1132, 22, 41, "Input", "ExpressionUUID" -> \
"57da98d1-2a7f-44a1-8e69-b2594d4e699f"],
Cell[14141, 427, 3350, 79, 531, "Output", "ExpressionUUID" -> \
"5e8e3cf9-ec4d-4b4d-bbd0-0ea2647cd791"]
}, Open  ]],
Cell[17506, 509, 329, 10, 12, "Text", "ExpressionUUID" -> \
"5d734c1a-a44f-4857-b70e-8f40871b91d0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17872, 524, 189, 3, 117, "Title", "ExpressionUUID" -> \
"cf742e8f-2a82-4ee3-83a0-ecaf4093ff06"],
Cell[18064, 529, 4946, 156, 367, "Input", "ExpressionUUID" -> \
"bf381daf-c953-4ef9-8d87-1317af8a4188"],
Cell[CellGroupData[{
Cell[23035, 689, 264, 6, 41, "Input", "ExpressionUUID" -> \
"ed6529c7-79a4-46ae-9e0a-45cb397878eb"],
Cell[23302, 697, 172, 3, 41, "Output", "ExpressionUUID" -> \
"d57c76f3-9b75-4c26-9187-3453d68b18ae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23511, 705, 267, 6, 41, "Input", "ExpressionUUID" -> \
"9a764de5-bd2e-4ca0-a04e-b98bb99e3be7"],
Cell[23781, 713, 190, 4, 41, "Output", "ExpressionUUID" -> \
"c1714b18-b53c-4485-aa57-163a53c97d3c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24008, 722, 180, 4, 41, "Input", "ExpressionUUID" -> \
"2a06f681-e074-408a-9b2a-89c0b56912ea"],
Cell[24191, 728, 131, 3, 41, "Output", "ExpressionUUID" -> \
"19d6515a-be46-45c7-bc63-d000edff173a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24359, 736, 186, 4, 41, "Input", "ExpressionUUID" -> \
"8486fac4-90da-439a-bbc6-07b2608be6a8"],
Cell[24548, 742, 131, 3, 41, "Output", "ExpressionUUID" -> \
"2a5e8e9d-3b85-4526-b033-a0c466a15e0b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24716, 750, 456, 14, 41, "Input", "ExpressionUUID" -> \
"3fabb1e5-ef4d-40a2-90e6-5b578c6eed43"],
Cell[25175, 766, 220, 6, 41, "Output", "ExpressionUUID" -> \
"8016c33c-d1db-4eb3-b28e-4cbfee05881b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25432, 777, 678, 20, 41, "Input", "ExpressionUUID" -> \
"7503a00a-36af-4b64-9dfa-66b80df7f4a0"],
Cell[26113, 799, 154, 3, 41, "Output", "ExpressionUUID" -> \
"73c3e80e-9643-475e-b7a0-ea1b18500395"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26304, 807, 222, 6, 41, "Input", "ExpressionUUID" -> \
"a0da0494-daf9-4d08-817c-f90fc1ab3eba"],
Cell[26529, 815, 129, 2, 41, "Output", "ExpressionUUID" -> \
"88d69087-91d8-40e5-9bfb-5487afc6b2df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26695, 822, 1201, 36, 70, "Input", "ExpressionUUID" -> \
"872f5eb1-bd49-4351-bea8-305e9b6527dd"],
Cell[27899, 860, 185, 4, 41, "Output", "ExpressionUUID" -> \
"e6c16efc-7c17-4f82-8136-4097b18ad85f"]
}, Open  ]],
Cell[28099, 867, 1209, 32, 70, "Input", "ExpressionUUID" -> \
"08586ce1-e669-41d8-b5ff-a662a11e2800"],
Cell[CellGroupData[{
Cell[29333, 903, 181, 4, 41, "Input", "ExpressionUUID" -> \
"8620d64d-251e-42a2-a66d-a58cb94b46b1"],
Cell[29517, 909, 131, 3, 41, "Output", "ExpressionUUID" -> \
"1695180e-a7a7-4a73-8e21-79ee5dd8c67d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29685, 917, 331, 6, 41, "Input", "ExpressionUUID" -> \
"3600af1d-9275-4980-ace9-27c22ba77a29"],
Cell[30019, 925, 477, 8, 41, "Output", "ExpressionUUID" -> \
"85b5c43d-affb-41f4-8c63-72a40e6db3ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30533, 938, 280, 5, 41, "Input", "ExpressionUUID" -> \
"2ecf0e0f-95f0-4b8b-b5fb-e626ac8fd477"],
Cell[30816, 945, 377, 7, 41, "Output", "ExpressionUUID" -> \
"89745dcc-aab4-4c9a-bbc6-c709fc0c50bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31230, 957, 141, 3, 41, "Input", "ExpressionUUID" -> \
"6b1eddf4-507e-4577-9398-6ecc90761803"],
Cell[31374, 962, 130, 3, 41, "Output", "ExpressionUUID" -> \
"3167eafd-7c4d-420e-8747-16f09e94f720"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31541, 970, 211, 5, 41, "Input", "ExpressionUUID" -> \
"f1692dcf-887b-4b12-951b-29bff924c79a"],
Cell[31755, 977, 130, 3, 41, "Output", "ExpressionUUID" -> \
"d605f047-7bfa-4854-bbe7-2de2f658aa65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31922, 985, 188, 5, 41, "Input", "ExpressionUUID" -> \
"8b481b49-4d19-4826-9607-194826a74408"],
Cell[32113, 992, 132, 3, 41, "Output", "ExpressionUUID" -> \
"1c9c57cc-e8ca-483d-83e7-ffb20147c78d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32282, 1000, 210, 5, 41, "Input", "ExpressionUUID" -> \
"4e2fe4a6-ac56-425a-add6-0ecc4e5a2f66"],
Cell[32495, 1007, 134, 3, 41, "Output", "ExpressionUUID" -> \
"1b29f100-31c4-40ab-9fa1-9d7e554ce43d"]
}, Open  ]],
Cell[32644, 1013, 329, 10, 12, "Text", "ExpressionUUID" -> \
"c8a7edc5-930b-4f79-a98f-7b99260e5783"],
Cell[CellGroupData[{
Cell[32998, 1027, 332, 7, 41, "Input", "ExpressionUUID" -> \
"5bd50b56-1c25-45c0-b5db-5f31da2e6dfd"],
Cell[33333, 1036, 204, 4, 41, "Output", "ExpressionUUID" -> \
"b91ea4d3-7db6-4379-ba24-3bf587d1cbcc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33574, 1045, 238, 6, 41, "Input", "ExpressionUUID" -> \
"89eece29-c1c2-4b60-8a23-9dfb72dbc892"],
Cell[33815, 1053, 130, 3, 41, "Output", "ExpressionUUID" -> \
"ddfa1d8f-27ef-4d2e-aed8-586665e5ea96"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33982, 1061, 236, 6, 41, "Input", "ExpressionUUID" -> \
"f8b0f76e-4686-42a2-a2c2-5c258d97a310"],
Cell[34221, 1069, 155, 3, 41, "Output", "ExpressionUUID" -> \
"82e2de8e-7d32-406b-a3fe-ee52166f873a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34413, 1077, 236, 6, 41, "Input", "ExpressionUUID" -> \
"86f16cab-5f57-467a-bba2-d109fb71ad66"],
Cell[34652, 1085, 131, 3, 41, "Output", "ExpressionUUID" -> \
"6b9adc3e-735c-4404-b985-a650fcc6c465"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34820, 1093, 234, 6, 41, "Input", "ExpressionUUID" -> \
"3a4116d1-bbf0-4127-8830-2ea4fde23792"],
Cell[35057, 1101, 131, 3, 41, "Output", "ExpressionUUID" -> \
"e4297d56-8c11-4fc1-9b13-68dde4ebd8ee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35225, 1109, 234, 6, 41, "Input", "ExpressionUUID" -> \
"29d5eef0-1530-4095-affc-d4d5f239cb18"],
Cell[35462, 1117, 127, 2, 41, "Output", "ExpressionUUID" -> \
"a9b16af9-970b-4911-8272-ea6258e1dc4c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35626, 1124, 856, 26, 98, "Input", "ExpressionUUID" -> \
"eceaca51-01fb-4f84-9e05-e70029617dba"],
Cell[36485, 1152, 186, 5, 41, "Output", "ExpressionUUID" -> \
"0d451315-fcfd-4c84-8003-1d43fc0be8a9"],
Cell[36674, 1159, 223, 6, 41, "Output", "ExpressionUUID" -> \
"db782478-9d1f-4c22-999b-278c47bba417"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36934, 1170, 154, 3, 41, "Input", "ExpressionUUID" -> \
"93a03767-1b20-4544-bf79-0d5e961d92bb"],
Cell[37091, 1175, 186, 5, 41, "Output", "ExpressionUUID" -> \
"b3ef6b6d-e531-4de7-a622-a62db656eaf9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37314, 1185, 514, 16, 41, "Input", "ExpressionUUID" -> \
"78db203b-2954-4be0-a1d2-aac3da2399ce"],
Cell[37831, 1203, 1118, 35, 93, "Output", "ExpressionUUID" -> \
"ab57b526-13ba-4eb0-90c3-66ca5c557532"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38986, 1243, 683, 21, 46, "Input", "ExpressionUUID" -> \
"c6748bf6-4bb8-4a83-b899-97ff3fe9b8bb"],
Cell[39672, 1266, 1511, 46, 91, "Output", "ExpressionUUID" -> \
"93953b59-25fc-4ae4-9199-f8f2781ead6b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41220, 1317, 545, 15, 66, "Input", "ExpressionUUID" -> \
"a23182c3-1688-4f52-9d5e-45861854341f"],
Cell[41768, 1334, 4022, 84, 475, "Output", "ExpressionUUID" -> \
"564df0f5-ef28-4c06-8c69-18af2ca0d658"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45827, 1423, 296, 8, 66, "Input", "ExpressionUUID" -> \
"bc625642-07b1-4733-b58f-697a121be5af"],
Cell[46126, 1433, 342, 10, 61, "Output", "ExpressionUUID" -> \
"58ef18a1-cb47-4ec1-a1ab-5762b7c21fd9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46505, 1448, 770, 24, 70, "Input", "ExpressionUUID" -> \
"8cf153db-c53d-4d14-9fae-4eefd6077680"],
Cell[47278, 1474, 1147, 36, 93, "Output", "ExpressionUUID" -> \
"873122cf-7392-4cbe-8825-22b4684b2dd3"]
}, Open  ]],
Cell[48440, 1513, 329, 10, 12, "Text", "ExpressionUUID" -> \
"1555ef18-152e-45c3-96a5-77d07c99b426"],
Cell[CellGroupData[{
Cell[48794, 1527, 806, 22, 41, "Input", "ExpressionUUID" -> \
"5d6f04d2-811e-4541-b990-956f073295b8"],
Cell[49603, 1551, 1140, 35, 93, "Output", "ExpressionUUID" -> \
"7c3ba9ca-24d1-4736-9f83-ca2248dadedf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50780, 1591, 787, 23, 46, "Input", "ExpressionUUID" -> \
"53ab55cd-f2d6-4185-86e1-e264aa795d72"],
Cell[51570, 1616, 1042, 33, 93, "Output", "ExpressionUUID" -> \
"0a293960-0a4e-47df-9db0-17a351a697ba"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52649, 1654, 739, 22, 46, "Input", "ExpressionUUID" -> \
"2236f95c-3a83-4dd9-8715-59d6321f219f"],
Cell[53391, 1678, 1415, 46, 93, "Output", "ExpressionUUID" -> \
"a9836688-074f-4a8d-ac2b-9bfafb6fae65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54843, 1729, 737, 22, 46, "Input", "ExpressionUUID" -> \
"de820768-0343-4919-87d3-cdef7a121ec3"],
Cell[55583, 1753, 1475, 50, 80, "Output", "ExpressionUUID" -> \
"86b66daf-8e85-478c-805c-dbf6391efb79"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57095, 1808, 557, 16, 66, "Input", "ExpressionUUID" -> \
"ae057de2-afce-47d2-affc-af637ff4259d"],
Cell[57655, 1826, 759, 25, 61, "Output", "ExpressionUUID" -> \
"6e1134fb-a516-4476-8a0c-85c98f23c732"]
}, Open  ]],
Cell[58429, 1854, 456, 15, 66, "Input", "ExpressionUUID" -> \
"2434fef2-612b-45e7-9f9d-2682da1b5c7d"],
Cell[CellGroupData[{
Cell[58910, 1873, 513, 16, 85, "Input", "ExpressionUUID" -> \
"6e592bf5-e948-4a1a-818e-eb62316cdb57"],
Cell[59426, 1891, 474, 15, 78, "Output", "ExpressionUUID" -> \
"a4afc4ea-7e05-4cff-95d6-7f47d64793e1"]
}, Open  ]],
Cell[59915, 1909, 329, 10, 10, "Text", "ExpressionUUID" -> \
"daedfe64-6965-483f-8988-7c34a9940b09"],
Cell[60247, 1921, 609, 23, 161, "Input", "ExpressionUUID" -> \
"62197eb8-8153-426a-b11e-3c3e259f6b43"],
Cell[CellGroupData[{
Cell[60881, 1948, 211, 5, 41, "Input", "ExpressionUUID" -> \
"c1f226d5-b698-4ab6-a59d-7dd537a93637"],
Cell[61095, 1955, 713, 20, 62, "Output", "ExpressionUUID" -> \
"112077bc-1ce0-4b9c-928d-6b5201153920"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61845, 1980, 209, 5, 41, "Input", "ExpressionUUID" -> \
"d7e054d1-23d3-4d42-8ad4-ab9f0b4402d5"],
Cell[62057, 1987, 711, 21, 62, "Output", "ExpressionUUID" -> \
"eb6e45ac-a41b-423e-a03d-76cfa1b4d846"]
}, Open  ]],
Cell[62783, 2011, 382, 13, 69, "Input", "ExpressionUUID" -> \
"2de03b10-1e31-43e9-af89-f77af36ee588"],
Cell[CellGroupData[{
Cell[63190, 2028, 445, 11, 41, "Input", "ExpressionUUID" -> \
"3d68ae70-a2de-4c50-bac2-f4de7f509666"],
Cell[63638, 2041, 1669, 54, 206, "Output", "ExpressionUUID" -> \
"89899439-7c75-478f-88d2-a1f438a95429"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65344, 2100, 365, 10, 41, "Input", "ExpressionUUID" -> \
"15f10657-f334-4958-903c-3217f411afd8"],
Cell[65712, 2112, 775, 26, 206, "Output", "ExpressionUUID" -> \
"a6251f33-4192-4468-9d5b-944a3a3d0e23"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66524, 2143, 179, 4, 41, "Input", "ExpressionUUID" -> \
"5264a4e1-266e-443d-96c3-c0883af61c8d"],
Cell[66706, 2149, 2386, 78, 206, "Output", "ExpressionUUID" -> \
"fbcc0947-ae76-4df5-9611-25ef22f13233"]
}, Open  ]],
Cell[69107, 2230, 329, 10, 12, "Text", "ExpressionUUID" -> \
"ed9983e5-c96e-42b7-995d-da8b9e973e42"],
Cell[69439, 2242, 1323, 44, 96, "Input", "ExpressionUUID" -> \
"4f2fc513-1045-474a-9488-44869c40e6fd"],
Cell[CellGroupData[{
Cell[70787, 2290, 183, 4, 41, "Input", "ExpressionUUID" -> \
"f03575d9-4361-4775-949a-300b3084f554"],
Cell[70973, 2296, 210, 4, 41, "Output", "ExpressionUUID" -> \
"ea2245a9-f247-4578-9478-0c4d8591f54c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71220, 2305, 191, 4, 41, "Input", "ExpressionUUID" -> \
"0b336564-3be7-40b0-b094-6fec4475b0c2"],
Cell[71414, 2311, 208, 4, 41, "Output", "ExpressionUUID" -> \
"824391f4-6e52-484d-8f9b-6f1a86999c8e"]
}, Open  ]],
Cell[71637, 2318, 147, 3, 70, "Input", "ExpressionUUID" -> \
"d00db88b-0743-42ad-b138-046c53ad037c"],
Cell[71787, 2323, 329, 10, 10, "Text", "ExpressionUUID" -> \
"dc31b617-5ebd-4fe8-9d34-55964d2df339"],
Cell[72119, 2335, 1158, 38, 70, "Input", "ExpressionUUID" -> \
"51d9c049-5e6d-4f4a-b869-8843f86505c1"],
Cell[CellGroupData[{
Cell[73302, 2377, 285, 5, 41, "Input", "ExpressionUUID" -> \
"cb9b5044-d845-4319-a4f1-517a630969d7"],
Cell[73590, 2384, 232, 4, 41, "Output", "ExpressionUUID" -> \
"faa9b7a7-3247-434d-83ce-038c2d7fe21b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73859, 2393, 289, 5, 41, "Input", "ExpressionUUID" -> \
"af6f0520-0a4f-41e5-af53-0278cd82f98a"],
Cell[74151, 2400, 234, 4, 41, "Output", "ExpressionUUID" -> \
"04bec5d6-5e8f-4b31-bbf9-856bf6f174e4"]
}, Open  ]],
Cell[74400, 2407, 329, 10, 12, "Text", "ExpressionUUID" -> \
"98a34093-d9d5-4c4a-9366-67f07dbed2c7"],
Cell[CellGroupData[{
Cell[74754, 2421, 791, 26, 66, "Input", "ExpressionUUID" -> \
"0f72347b-259e-42a8-9819-ceff6b24127e"],
Cell[75548, 2449, 451, 15, 61, "Output", "ExpressionUUID" -> \
"3cec143a-bd35-4fde-8df2-d04d672d1f08"]
}, Open  ]],
Cell[76014, 2467, 329, 10, 12, "Text", "ExpressionUUID" -> \
"c73c68e9-b128-4899-b1f2-95cd5ef4778d"],
Cell[CellGroupData[{
Cell[76368, 2481, 355, 10, 41, "Input", "ExpressionUUID" -> \
"cffdc75e-eed9-42c9-b41a-b188eb06871c"],
Cell[76726, 2493, 246, 7, 41, "Output", "ExpressionUUID" -> \
"ad232fef-6faf-4153-85de-860e627ad919"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77009, 2505, 381, 11, 41, "Input", "ExpressionUUID" -> \
"a8b6185a-a7d9-46bf-91fb-03c224ed743d"],
Cell[77393, 2518, 267, 9, 41, "Output", "ExpressionUUID" -> \
"0d4f446b-4dd4-4386-88d0-19ca06e80fec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77697, 2532, 379, 11, 41, "Input", "ExpressionUUID" -> \
"cb2347a1-b233-4f29-be4f-3dd86cbb7740"],
Cell[78079, 2545, 372, 13, 41, "Output", "ExpressionUUID" -> \
"32ac05bc-ffca-4ce1-85af-19c481d8fd26"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78488, 2563, 379, 11, 41, "Input", "ExpressionUUID" -> \
"ad81e92b-a294-4f41-b509-ac724fa02a3a"],
Cell[78870, 2576, 590, 21, 61, "Output", "ExpressionUUID" -> \
"da78de81-7168-46e8-9efb-780c74d55f84"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79497, 2602, 378, 11, 41, "Input", "ExpressionUUID" -> \
"3aca6a55-9967-4eaf-b143-5edaaa77dd0c"],
Cell[79878, 2615, 889, 32, 61, "Output", "ExpressionUUID" -> \
"ee0822b6-ba87-4d1e-bde4-c7129751458c"]
}, Open  ]],
Cell[80782, 2650, 329, 10, 12, "Text", "ExpressionUUID" -> \
"733a7c9b-fee6-489f-9fd8-cf6826422920"],
Cell[81114, 2662, 459, 14, 41, "Input", "ExpressionUUID" -> \
"b7be657d-8033-4bd8-8c90-2f35a8f6eefb"],
Cell[81576, 2678, 359, 11, 66, "Input", "ExpressionUUID" -> \
"4131e1aa-d216-4465-b6b6-86b74f6a23df"],
Cell[CellGroupData[{
Cell[81960, 2693, 181, 4, 41, "Input", "ExpressionUUID" -> \
"ebac73ce-8ce1-4da7-821b-3d5cc71b1367"],
Cell[82144, 2699, 154, 3, 41, "Output", "ExpressionUUID" -> \
"b39b5811-0479-4f92-8d80-071b1dbc7d92"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82335, 2707, 185, 4, 41, "Input", "ExpressionUUID" -> \
"64d42e50-e862-4c6a-bfdf-4a6281867be3"],
Cell[82523, 2713, 158, 3, 41, "Output", "ExpressionUUID" -> \
"f9c5ef24-2418-4d1b-a20d-3a6e17a88c36"]
}, Open  ]],
Cell[82696, 2719, 329, 10, 12, "Text", "ExpressionUUID" -> \
"1eb175b3-aaeb-46f2-9893-df2e5db1033d"],
Cell[83028, 2731, 626, 21, 96, "Input", "ExpressionUUID" -> \
"12e04753-5a87-4acc-b9a9-291693363378"],
Cell[CellGroupData[{
Cell[83679, 2756, 228, 5, 41, "Input", "ExpressionUUID" -> \
"06b34ea7-9392-473a-8a1a-be308ac44186"],
Cell[83910, 2763, 230, 5, 62, "Output", "ExpressionUUID" -> \
"f55f0fa7-cdc1-4e47-92b9-1513a17fda97"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84177, 2773, 237, 5, 41, "Input", "ExpressionUUID" -> \
"bb5d36db-70fe-4c1e-835e-87b6a090ca18"],
Cell[84417, 2780, 200, 4, 61, "Output", "ExpressionUUID" -> \
"125efa0e-7213-4dc9-9c5c-21c9c3494e02"]
}, Open  ]],
Cell[84632, 2787, 329, 10, 12, "Text", "ExpressionUUID" -> \
"f76108d3-65ef-4f75-a873-30d0ebde199f"],
Cell[84964, 2799, 1335, 40, 70, "Input", "ExpressionUUID" -> \
"69cbf9c7-eb28-4f97-a06a-b90ac9d1854f"],
Cell[CellGroupData[{
Cell[86324, 2843, 233, 5, 41, "Input", "ExpressionUUID" -> \
"21f5a979-cf1e-42df-92f0-e2ff09fc6cd8"],
Cell[86560, 2850, 373, 6, 41, "Output", "ExpressionUUID" -> \
"1250b40b-7e6a-4237-8abb-888071242664"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86970, 2861, 256, 5, 41, "Input", "ExpressionUUID" -> \
"3a8c94bd-5cda-43f1-b7ff-b261daaea413"],
Cell[87229, 2868, 394, 6, 41, "Output", "ExpressionUUID" -> \
"1c5ce5f8-6a2f-47b3-a9e6-c0dae9322643"]
}, Open  ]],
Cell[87638, 2877, 329, 10, 12, "Text", "ExpressionUUID" -> \
"ea739c68-dcab-4e71-bc4c-2c5c3afec17f"],
Cell[CellGroupData[{
Cell[87992, 2891, 559, 16, 41, "Input", "ExpressionUUID" -> \
"26b1ce96-4088-4cdf-b4fd-9f7555be2a7c"],
Cell[88554, 2909, 182, 4, 41, "Output", "ExpressionUUID" -> \
"04be7ad9-8e29-4ae2-bae1-85fbd1dc26bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88773, 2918, 232, 5, 41, "Input", "ExpressionUUID" -> \
"d75db835-397b-462a-afaf-797b3fc9bd25"],
Cell[89008, 2925, 176, 2, 41, "Output", "ExpressionUUID" -> \
"513188b3-22cd-4eba-9cf0-436824c9397f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89221, 2932, 416, 12, 41, "Input", "ExpressionUUID" -> \
"2a6d7ca2-633a-4380-a918-3e8f954bbe5d"],
Cell[89640, 2946, 132, 3, 41, "Output", "ExpressionUUID" -> \
"bdb92896-2f3a-4810-b56c-381b0b6427dd"]
}, Open  ]],
Cell[89787, 2952, 1811, 57, 70, "Input", "ExpressionUUID" -> \
"c0a203ea-78f1-48e2-b862-fd53df49909f"],
Cell[CellGroupData[{
Cell[91623, 3013, 186, 4, 41, "Input", "ExpressionUUID" -> \
"494556db-3567-4ae0-9c8d-94c94b0fa113"],
Cell[91812, 3019, 310, 5, 41, "Output", "ExpressionUUID" -> \
"695f2295-ae46-4b62-931a-cfb3f50cd000"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92159, 3029, 184, 4, 41, "Input", "ExpressionUUID" -> \
"db1153c6-614b-4e5f-a33b-140664ac1697"],
Cell[92346, 3035, 234, 4, 41, "Output", "ExpressionUUID" -> \
"557534e5-1bd7-4c0d-ba97-64de03e6523e"]
}, Open  ]],
Cell[92595, 3042, 601, 20, 41, "Input", "ExpressionUUID" -> \
"e83070c0-da20-42ac-8386-d69e425731ef"],
Cell[CellGroupData[{
Cell[93221, 3066, 185, 4, 41, "Input", "ExpressionUUID" -> \
"f5775b00-73dc-48f3-894c-d62f2dbf3415"],
Cell[93409, 3072, 132, 3, 41, "Output", "ExpressionUUID" -> \
"41e41357-a83f-48b6-a746-86c402877b9e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93578, 3080, 228, 5, 66, "Input", "ExpressionUUID" -> \
"1897d745-c1cf-487b-8825-a5339d6f40ac"],
Cell[93809, 3087, 134, 3, 41, "Output", "ExpressionUUID" -> \
"9be4e5bc-4920-4132-bc05-9036c81d8534"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93980, 3095, 454, 14, 41, "Input", "ExpressionUUID" -> \
"c2526a79-bc42-4d9e-93ae-943b9a43697e"],
Cell[94437, 3111, 220, 6, 41, "Output", "ExpressionUUID" -> \
"e6919728-3df2-4c71-8487-a460c1f96811"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94694, 3122, 285, 8, 41, "Input", "ExpressionUUID" -> \
"ce017c6e-7da7-4c08-ab12-abcc198293c9"],
Cell[94982, 3132, 307, 10, 61, "Output", "ExpressionUUID" -> \
"ac68356d-af19-48a0-a3dd-1b77cdb395e2"]
}, Open  ]],
Cell[95304, 3145, 329, 10, 12, "Text", "ExpressionUUID" -> \
"6f6d131b-06a2-4052-9ded-c9d7e8765a8d"],
Cell[95636, 3157, 5112, 163, 184, "Input", "ExpressionUUID" -> \
"f17a6510-5298-48f5-a9b9-fd66322e8c13"],
Cell[CellGroupData[{
Cell[100773, 3324, 275, 5, 41, "Input", "ExpressionUUID" -> \
"1d343e74-7da2-49eb-b449-3285917adf7e"],
Cell[101051, 3331, 418, 7, 41, "Output", "ExpressionUUID" -> \
"cf9e1f49-56eb-4380-9c5a-0d949ba1600d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[101506, 3343, 915, 25, 41, "Input", "ExpressionUUID" -> \
"9ec4125c-f0d2-4664-b1ac-5810e0419f8d"],
Cell[102424, 3370, 318, 4, 41, "Output", "ExpressionUUID" -> \
"a9c90ebf-e594-48df-831f-2716205fd6d3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102779, 3379, 726, 20, 41, "Input", "ExpressionUUID" -> \
"bb7438c4-1a00-4759-b5ad-987a70d3031d"],
Cell[103508, 3401, 255, 4, 41, "Output", "ExpressionUUID" -> \
"6fef4ac4-5855-4900-a91a-a6704fd0579a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103800, 3410, 182, 4, 41, "Input", "ExpressionUUID" -> \
"cd14e3e3-77a7-4ae7-8c10-24ee8acba898"],
Cell[103985, 3416, 349, 6, 41, "Output", "ExpressionUUID" -> \
"9701f11e-15f7-4bfb-8b00-4e5f45da2d55"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104371, 3427, 183, 4, 41, "Input", "ExpressionUUID" -> \
"33841943-06e6-46c5-8160-5f476106e1a6"],
Cell[104557, 3433, 330, 5, 41, "Output", "ExpressionUUID" -> \
"fe54b8bd-1744-44ee-9ba8-9c9e330b7d26"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104924, 3443, 162, 4, 41, "Input", "ExpressionUUID" -> \
"6f205060-9722-4c4b-8953-85f89e761fbc"],
Cell[105089, 3449, 180, 3, 41, "Output", "ExpressionUUID" -> \
"757502d6-5ca5-43c6-b6e5-7be62f5b52f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105306, 3457, 163, 4, 41, "Input", "ExpressionUUID" -> \
"e532e1a6-3e89-4767-9560-5ec3fb6f0bdf"],
Cell[105472, 3463, 159, 3, 41, "Output", "ExpressionUUID" -> \
"264299b9-eb39-404d-9d24-53a63770f7e3"]
}, Open  ]],
Cell[105646, 3469, 2165, 73, 133, "Input", "ExpressionUUID" -> \
"be301f2b-a712-420e-8fec-70c01824755f"],
Cell[CellGroupData[{
Cell[107836, 3546, 183, 4, 41, "Input", "ExpressionUUID" -> \
"d26f8d4f-08e7-4b47-ad1c-2ff006bb0ae7"],
Cell[108022, 3552, 161, 3, 41, "Output", "ExpressionUUID" -> \
"64214e31-4846-4b7f-8471-f3a9d03619ae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108220, 3560, 182, 4, 41, "Input", "ExpressionUUID" -> \
"076dc55d-6042-4e8f-ab26-9e0003559ca0"],
Cell[108405, 3566, 157, 3, 41, "Output", "ExpressionUUID" -> \
"3786a094-e34f-437d-af68-da763f8fe78b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108599, 3574, 181, 4, 41, "Input", "ExpressionUUID" -> \
"f7f3a68c-e6b0-4da2-8912-49dc581183dd"],
Cell[108783, 3580, 155, 3, 41, "Output", "ExpressionUUID" -> \
"423b9db3-5c15-4e51-ae60-52a74884ceed"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108975, 3588, 1266, 43, 66, "Input", "ExpressionUUID" -> \
"54367892-4f73-4efc-8c65-0a587a67b16f"],
Cell[110244, 3633, 554, 19, 61, "Output", "ExpressionUUID" -> \
"492fd23b-d2d3-478b-aa2c-3f37df7436e6"]
}, Open  ]],
Cell[110813, 3655, 329, 10, 12, "Text", "ExpressionUUID" -> \
"8a7d290a-9c0f-4227-8c5e-c702f0605b44"],
Cell[111145, 3667, 5047, 165, 280, "Input", "ExpressionUUID" -> \
"4d5d1337-4571-446f-92aa-8efc288cd1fc"],
Cell[CellGroupData[{
Cell[116217, 3836, 180, 4, 41, "Input", "ExpressionUUID" -> \
"aeae0819-99d4-4a5f-96e4-8ef92ed459ea"],
Cell[116400, 3842, 185, 3, 41, "Output", "ExpressionUUID" -> \
"86f6e8f5-222a-4de5-9188-ef5563587afb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116622, 3850, 187, 4, 41, "Input", "ExpressionUUID" -> \
"c24aae0a-3899-4ddc-ba3a-f4a91df531fc"],
Cell[116812, 3856, 187, 3, 41, "Output", "ExpressionUUID" -> \
"ccfe312e-21b8-415b-9662-5c8ddcd0b35a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117036, 3864, 186, 4, 41, "Input", "ExpressionUUID" -> \
"5b2066c0-8f4f-433c-bf31-121f15fc5a56"],
Cell[117225, 3870, 158, 2, 41, "Output", "ExpressionUUID" -> \
"778cfcbc-1871-4572-8f73-0c81b728f073"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117420, 3877, 184, 4, 41, "Input", "ExpressionUUID" -> \
"10e44a9c-6aea-4927-87b9-e222c4ab7ac0"],
Cell[117607, 3883, 237, 4, 41, "Output", "ExpressionUUID" -> \
"6a6983a8-93e2-4332-97f3-f9c5f173dbac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117881, 3892, 188, 4, 41, "Input", "ExpressionUUID" -> \
"a115309d-cb21-4632-922c-4839ff475757"],
Cell[118072, 3898, 161, 3, 41, "Output", "ExpressionUUID" -> \
"99e22863-2c72-4015-a4c4-1ecbf0b52163"]
}, Open  ]],
Cell[118248, 3904, 1677, 57, 124, "Input", "ExpressionUUID" -> \
"d09c3e66-78cb-4075-ad41-056d94aa9e3e"],
Cell[119928, 3963, 2808, 90, 112, "Input", "ExpressionUUID" -> \
"ebd371fa-6f43-4fa3-86ba-25ade4fa57ec"],
Cell[CellGroupData[{
Cell[122761, 4057, 181, 4, 41, "Input", "ExpressionUUID" -> \
"c1241163-3bdd-4eb9-a931-03c38c0bfb77"],
Cell[122945, 4063, 205, 4, 41, "Output", "ExpressionUUID" -> \
"fb326fb3-cff4-4121-a066-43b0b77aabab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123187, 4072, 184, 4, 41, "Input", "ExpressionUUID" -> \
"60a036b5-1375-4539-ba92-8ff44a5b9e86"],
Cell[123374, 4078, 179, 3, 41, "Output", "ExpressionUUID" -> \
"36bb1855-bc5c-4480-ba08-a82c055850af"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123590, 4086, 1757, 59, 124, "Input", "ExpressionUUID" -> \
"f57b6143-664e-428c-bb7d-5bff763ac255"],
Cell[125350, 4147, 802, 28, 61, "Output", "ExpressionUUID" -> \
"01a33469-8c55-4d58-bc80-179b9d3f15aa"]
}, Open  ]],
Cell[126167, 4178, 329, 10, 12, "Text", "ExpressionUUID" -> \
"5fa3e198-fef5-4396-9af8-dadc139fa892"],
Cell[126499, 4190, 4873, 161, 279, "Input", "ExpressionUUID" -> \
"e0dc2b5e-d5f8-4736-b76a-a478181254a8"],
Cell[CellGroupData[{
Cell[131397, 4355, 205, 4, 41, "Input", "ExpressionUUID" -> \
"dfef6795-cf5b-4c2c-9203-68b6acebbf45"],
Cell[131605, 4361, 171, 3, 41, "Output", "ExpressionUUID" -> \
"0ac7ce9f-d0fa-452a-81bb-b0995edb7a3f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131813, 4369, 210, 4, 41, "Input", "ExpressionUUID" -> \
"5844f1f6-d5bd-4c9e-98f5-4b53ef1c8fb9"],
Cell[132026, 4375, 172, 3, 41, "Output", "ExpressionUUID" -> \
"07df6bf4-01da-405a-af8b-9744d1e55916"]
}, Open  ]],
Cell[CellGroupData[{
Cell[132235, 4383, 186, 4, 41, "Input", "ExpressionUUID" -> \
"dbd01016-915d-463e-b8bf-ebd081d317d8"],
Cell[132424, 4389, 176, 3, 41, "Output", "ExpressionUUID" -> \
"4535b9aa-0a55-43fa-a5fc-82a01525d5dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[132637, 4397, 331, 10, 41, "Input", "ExpressionUUID" -> \
"aa942bd3-3872-4938-af6f-4414ae238fa6"],
Cell[132971, 4409, 517, 15, 41, "Output", "ExpressionUUID" -> \
"d1689b74-97e2-4e40-b4dd-670328a7a3b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133525, 4429, 183, 4, 41, "Input", "ExpressionUUID" -> \
"888ea8e6-6767-44e4-8314-8b38615bc09f"],
Cell[133711, 4435, 150, 3, 41, "Output", "ExpressionUUID" -> \
"01e54e7c-a903-45d7-865d-0a3d740f6f87"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133898, 4443, 2531, 86, 124, "Input", "ExpressionUUID" -> \
"03d5abf3-ae5d-413f-a3ee-58282c099a22"],
Cell[136432, 4531, 879, 30, 61, "Output", "ExpressionUUID" -> \
"b0dbe905-1e95-4c2d-abdc-54b5a69b6880"]
}, Open  ]],
Cell[137326, 4564, 329, 10, 12, "Text", "ExpressionUUID" -> \
"4f90ee97-89ad-4e69-9797-beb2adc4f402"],
Cell[137658, 4576, 4762, 151, 326, "Input", "ExpressionUUID" -> \
"e37b9ea5-c5ed-4344-8cb7-51785a9b3f65"],
Cell[142423, 4729, 313, 10, 69, "Input", "ExpressionUUID" -> \
"3cebd776-1d7f-45c2-9a0c-850757d5ec93"],
Cell[CellGroupData[{
Cell[142761, 4743, 314, 6, 41, "Input", "ExpressionUUID" -> \
"ece7e3a4-bb35-4e67-9186-49fffef065b9"],
Cell[143078, 4751, 258, 6, 61, "Output", "ExpressionUUID" -> \
"59dbc123-1798-4060-9d5d-7807fa40a961"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143373, 4762, 229, 5, 41, "Input", "ExpressionUUID" -> \
"fd3d09f3-63dd-46e1-b01b-769b795992ef"],
Cell[143605, 4769, 250, 5, 61, "Output", "ExpressionUUID" -> \
"e77e613f-28ad-4f84-9088-da454995895a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143892, 4779, 225, 5, 41, "Input", "ExpressionUUID" -> \
"5b82791f-6265-4f9a-a314-2f49e15c192e"],
Cell[144120, 4786, 323, 10, 96, "Output", "ExpressionUUID" -> \
"ea6d3439-15ca-47b2-a555-9527b3a40251"]
}, Open  ]]
}, Open  ]]
}
]
*)

